 // - some name conventions:
//   []=brackets   {}=braces    ()=parentheses
{$DEFINE COMMANDSUNIT} // Only in commands unit
{$I stdefine.inc}
Unit Commands;
Interface
{$IFDEF KOL}
uses Kolibri;
{$ENDIF}
{$IFDEF DPMI32}
  {$I DOSKEYB.INC}
{$ELSE !DPMI32}
  {$IFDEF LINUX}
  {$IFDEF HAIKUKEYB}
  {$I HAIKEYB.INC}
  {$ELSE !HAIKUKEYB}
  {$I LNXKEYB.INC}
  {$ENDIF HAIKUKEYB}
  {$ELSE !LINUX}
  {$IFDEF KOL}
  {$IFDEF SIG}
  {$I SIGKEYB.INC}
  {$ELSE !SIG}
  {$I KOLKEYB.INC}
  {$ENDIF SIG}
  {$ELSE !KOL}
  {$IFDEF OS2}
  {$I OS2KEYB.INC}
  {$ELSE !OS2}
  {$I WINKEYB.INC}
  {$ENDIF OS2}
  {$ENDIF KOL}
  {$ENDIF LINUX}
{$ENDIF DPMI32}
  {$I INCCMDS.INC} // to avoid errors in RCP
const
  kbUpUp = $554800;
  kbDnUp = $555000;
//  kbPrintableCharCodes = [' '..#254];
//  kbCursorScanCodes    = [Hi(kbBack), Hi(kbLeft), Hi(kbRight),Hi(kbHome), Hi(kbEnd), Hi(kbDel)];
//
  ofMaxColTypes1 = 27; // 27*1
  ofMaxColTypes3 = 81; // 27*3

{ FileMode constants }
  fmReadOnly  =   0;
  fmWriteOnly =   1;
  fmReadWrite =   2;
  fmDenyAll   = $10;
  fmDenyWrite = $20;
  fmDenyRead  = $30;
  fmDenyNone  = $40;
  fmNoInherit = $80;

  fmDeny      = $FF0F;               { Mask to apply fmDenyXXX }

{ DOSError codes }
  deNoError                   =  0;
  deInvalidFunctionNumber     =  1; //Invalid function number
  deFileNotFound              =  2;
  dePathNotFound              =  3;
  deTooManyOpenFiles          =  4; //Too many open files (no handles left)
  deAccessDenied              =  5;
  deInvalidHandle             =  6;
  deMCBsDestroyed             =  7; //Memory control blocks destroyed
  deNotEnoughMemory           =  8;
  deInvalidMemoryBlockAddress =  9; //Invalid memory block address
  deInvalidEnvironment        = 10;
  deInvalidFormat             = 11;
  deInvalidAccessMode         = 12; //Invalid access mode (open mode is invalid)
  deInvalidData               = 13;
  deReserved                  = 14;
  deInvalidDrive              = 15;
  deRemoveCurrentDirectory    = 16; //Attempt to remove current directory
  deNotSameDevice             = 17;
  deNoMoreFiles               = 18;
  deSharingViolation          = 32;
  deLockViolation             = 33;
  deInt24Fail                 = 83;
  deBadNetPath                = 53;  // WINDOWS/OS2
  deOpenFailed                = 110; // WINDOWS/OS2
  // RCP cannot parse it any other way
  {$IFDEF WIN32}
  deFileExists                = 183;
  {$ENDIF}
  {$IFDEF LINUX}
  deFileExists                = -17;
  {$ENDIF}
  {$IFDEF OS2}
  deFileExists                = 80;
  {$ENDIF}
  {$IFDEF DPMI32}
  deFileExists                = deAccessDenied;
  {$ENDIF}
  {$IFDEF KOL}
  deFileExists                = ErrAccDenied;
  {$ENDIF}

{ Editor Defaults }
  ebfCBF = 1 shl  0; {Create Backups}
  ebfBSU = 1 shl  1; {Backspace Unindents}
  ebfABr = 1 shl  2; {Auto Brackets}
  ebfAId = 1 shl  3; {Auto Indent}
  ebfAwr = 1 shl  4; {Auto Wrap}
  ebfJwr = 1 shl  5; {Justify on Wrap}
  ebfVBl = 1 shl  6; {Vertical Blocks}
  ebfOfl = 1 shl  7; {Optimal Fill}
  ebfHLn = 1 shl  8; {Highlite Line}
  ebfHCl = 1 shl  9; {"        Column}
  ebfPBl = 1 shl 10; {Persistent Blocks}
  ebfObl = 1 shl 11; {Overwrite Blocks}
  ebfLck = 1 shl 12; {Lock File}
  ebfTRp = 1 shl 13; {Tab Replace}
  ebfRT  = 1 shl 14; {Delete Right Spaces 㤠 ࠢ ஡}
  ebfROd = 1 shl 15; {Run Open Dialog   ""}
  ebfUnlimitUnindent     = 1 shl 16;
  ebfKoi8rKeyMap         = 1 shl 17;
  ebfOnlyBlockConv       = 1 shl 18;
  ebfAutoScopeDetect     = 1 shl 19;
  ebfShowBookmarks       = 1 shl 20;
  ebfAutodetectCodePage  = 1 shl 21;
  ebfClearUndoWhenSave   = 1 shl 22;
  ebfNonFixedTabs        = 1 shl 23; {Smart Tabs}
  ebfTrimRightEnd        = 1 shl 24; {AH18.11.03 Trim right spaces on kbEnd}
  ebfUnmarkInsert        = 1 shl 25; {AH19.11.03 Unmark block after insert}
  ebfAlwaysReload        = 1 shl 26; {AH20.11.03}
  ebfForceNewlineAtEOF   = 1 shl 27; {AH 18-09-07 Always save file with a newline before EOF}
  ebfSmartBackIndent     = 1 shl 28; {AH18.01.04}
  ebfSmartHome           = 1 shl 29; {AH 16-03-04 Smart Home}
  ebfFoundIsBlock        = 1 shl 30; {AH 16-03-04 Found String is Block}
  ebfSmartLineDuplication= 1 shl 31; {AH 16-05-04 also dupe Blocks}

  edeSmartPadAutoSave    = 1 shl  0; {AH 14-07-04 enhanced editor defaults}
  edeSmartPadMaxiMize    = 1 shl  1;
  edeSmartPadSeparators  = 1 shl  2;
  edeAutoSaveOnOpen      = 1 shl  3;
  edeResetSearchDir      = 1 shl  4;
  edeMove2LastReplace    = 1 shl  5;
  edeDualAltLeftRight    = 1 shl  6; {AH  7-08-04 Dual Alt-Cursor <> support}
  edeShowLineNumbers     = 1 shl  7; {AH 28-11-2004 Line numbers on left side}
  edeTABMovesBlocks      = 1 shl  8; {AH  8-01-05 TAB handles blocks}
  edeAltWordDel          = 1 shl  9; {AH  2-12-05 Alternate word del behaviour}
  edeMovetoEOB           = 1 shl 10; {AH 16-06-06 Move cursor to EOB}
  edeDelEmptyLines       = 1 shl 11; {AH 28-09-06 delete empty lines at the EOF}
  edeNewFileLoading      = 1 shl 12; {AH  7-05-07 temporary: select between old and new file loading code}
  edeMixedLineBreaks     = 1 shl 13; {AH 17-05-07 support for mixed line breaks in files}
  edeWriteEOFChar        = 1 shl 14; {CandyMan 01-06-2020 Write EOF char at end of file}
  edeAutoSpaces          = 1 shl 15; {CandyMan 22-08-2021 Auto spaces}
  edeFreezeText          = 1 shl 16; {CandyMan 11-08-2022}
  edePasteGoesToEnd      = 1 shl 17; {CandyMan 23-08-2021}

  edlnEveryLine          = 0; // line number display
  edlnEvery5thLine       = 1;
  edlnEvery10thLine      = 2;

{ Viewer Defaults / Constants}
  viWrap         = $01;
  viWord         = $02;
  viHilite       = $04;
  viTabRepl      = $08;
  viNewOpen      = $10;
  viEnterClose   = $20;
  viF3Close      = $40;
  viUsePKT       = $80;
  viUseMSG       = $100;
  viViewNewExe   = $200;
  viAlwaysReload = $400;
  viPersBlocks   = $800;
  viSpacePgDown  = $1000;
  viModTable     = $2000;
  viColorMod     = $4000; {AH3.11.03}
  viBackup       = $8000; {AH16.11.03}
  viHiliteLine   = $10000;{AH 23-12-03}
  viHiliteCol    = $20000;{AH 23-12-03}
  videtCodePage  = $40000;{G  8-05-2020}


  vmText         = 0; {Viewmodes}
  vmDump         = 1;
  vmHex          = 2;
  vmAsm          = 3;
  vmDBase        = 99;
  vmValid        = [vmText, vmDump, vmHex {$IFDEF DISASM} , vmAsm {$ENDIF}];

  wmNone         = 0; {Wrapping modes}
  wmWidth        = 1;
  wmWords        = 2;

{AH15.11.03 New BufModified Flags showing if buffer changed by...}
  bmTyped        = 1; { overwriting a value }
  bmFunction     = 2; { inserting/removing bytes }

{ DBF Viewer Defaults / Constants Garl 15-07-2007}
  dbQuote        = $01;
  dbEnableDelete = $02;
  dbConfDel      = $04;
  dbHglFldName   = $08;
  dbCutLastField = $10;
  dbHdGridLines  = $20;

{ Codepages list used in viwer\editor}
  cpDOS          = $0000; // 866
  cpWIN          = $0001; // 1251
  cpKOI          = $0002; // 20866
  cpUtf8         = $0004; // 65001
  cpUtf7         = $0008; // 65000
  cpUtf16LE      = $0010; // 1200
  cpUtf16BE      = $0020; // 1201


{ NetworkSetup default Garl 22-10-2018 }
  ntwDetectIP    = $01;
  ntwDetectMAC   = $02;
  ntwParseMAC    = $04;
  ntwChkAdmins   = $08;
  ntwChkDisks    = $10;
  ntwChkServices = $20;
  ntwWindowsLogin= $40;

{ Disassembler Defaults }
  disUpCase      = $1;
  disSynHighlite = $2;
  disSubNegOfs   = $4;

{ Commandoline Options }
  oclUM1                  = $0001;
  oclUM2                  = $0002;
  oclTimer                = $0004;
  oclSave                 = $0008; {AH 28-10-05 Save cmdline data}
  oclAlwaysHandleCmds     = $0010; {AH 28-10-05 Always try to interpret cmdline}
  oclEnableFilenameMacros = $0020; {AH 24-03-07 use !$# macros on commandline}
  oclSaveCmdlineMode      = $0040; {AH 24-03-07 don't change cmdline mode automatically}
  oclShowDefinedCmdLine   = $0080; {CandyMan 14-09-2019 show user defined command line}

{ Interface Defaults }
  ouiClock               = $0001;
  ouiSeconds             = $0002;
  ouiCentury             = $0004;
  ouiDay                 = $0008;
  ouiLAlign              = $0010;

  ouiHideMenu             =  $0001;
  ouiHideStatus           =  $0002;
  ouiEsc                  =  $0004;
  ouiBlockInsertCursor    =  $0008;
  ouiStoreEditorPosition  =  $0010;
  ouiStoreViewerPosition  =  $0020;
  ouiTrackEditors         =  $0040;
  ouiTrackViewers         =  $0080;
  ouiTrackDirs            =  $0100;
  ouiHideDriveInfo        =  $0200;
  ouiStoreGrabber         =  $0400;
  ouiStoreMouse           =  $0800;
  ouiShowScrollbar        =  $1000;
  ouiPreserveMenuPos      =  $2000;
  ouiNewStyleMenus        =  $4000;
  ouiWinSwitchOpts        =  $8000;
  ouiWinInfo              = $10000;
  ouiOldRename            = $20000;
  ouiQuickLng             = $40000;
  ouiMNUUpperDir          = $80000;
  ouiShowDlgMarkers       = $100000;{AH  4-06-04}
  ouiDontEchoExecExt      = $200000;{AH 17-07-04}
  ouiDontReportMissingMNU = $400000;{AH 14-08-04}
  ouiShiftTabSwitchWindow = $800000;{AH  5-01-05 Use ShiftTab window switch}
  ouiDontWrapButtonsBoxes = $1000000;{AH 2-07-05 dialogs buttons and boxes wrap}
  ouiAllowMultiHelpWin    = $2000000;{AH  9-10-06 allow multiple open help windows}
  ouiAutoShortcuts        = $4000000;{AH 23-03-07 automatic keyboard shortcut generation}
  ouiNewHistory           = $8000000;{AH  3-11-07 Use new inputline histories}
  ouiTrackDecoders        = $10000000;
  ouiAltCalendar          = $20000000;
  ouiDisableSpinner       = $40000000;
  ouiViewInFileDialog     = $80000000;

  ouiMakeCopyDialogData   = $00000001;{CandyMan 05-08-2020 - make local copy TDialog data}
  ouiMarkDefaultItemMenu  = $00000002;{CandyMan 11-08-2020}
  ouiTransparentDesktop   = $00000004;{CandyMan 22-08-2020}
  ouiShowScrollBarInMenu  = $00000008;{CandyMan 22-08-2020}
  ouiShowItemCountInMenu  = $00000010;{CandyMan 12-09-2020}
  ouiShowClusterOnFrame   = $00000020;{CandyMan 15-09-2020}
{$IFDEF DPMI32}
  ouiHandleMultiKeyPress  = $00000040;{CandyMan 07-03-2020}
  ouiAutoHideCmdLine      = $00000080;{CandyMan 12-06-2021}
  ouiMinus1LinesShow      = $00000100;{CandyMan 19-08-2022}
{$IFDEF SHOWHINT}
  ouiHideHint             = $00000200;{CandyMan 19-08-2022}
  {$IFDEF SPEAKER}
  ouiSounds               = $00000400;{CandyMan 23-08-2022}
  ouiDetectCluster        = $00000800;{CandyMan 19-01-2023}
  {$ELSE !SPEAKER}
  ouiDetectCluster        = $00000400;{CandyMan 19-01-2023}
  {$ENDIF SPEAKER}
{$ELSE !SHOWHINT}
{$IFDEF SPEAKER}
  ouiSounds               = $00000200;{CandyMan 23-08-2022}
  ouiDetectCluster        = $00000400;{CandyMan 19-01-2023}
{$ELSE !SPEAKER}
  ouiDetectCluster        = $00000200;{CandyMan 19-01-2023}
{$ENDIF SPEAKER}
{$ENDIF SHOWHINT}
{$ELSE !DPMI32}
  ouiAutoHideCmdLine      = $00000040;{CandyMan 12-06-2021}
{$IFDEF SHOWHINT}
  ouiHideHint             = $00000080;{CandyMan 19-08-2022}
  {$IFDEF SPEAKER}
  ouiSounds               = $00000100;{CandyMan 23-08-2022}
  {$ENDIF SPEAKER}
{$ELSE !SHOWHINT}
  {$IFDEF SPEAKER}
  ouiSounds               = $00000080;{CandyMan 23-08-2022}
  {$ENDIF SPEAKER}
{$ENDIF SHOWHINT}
{$ENDIF DPMI32}

{ History constants }
  hisShowDate            = $01;
  hisShowSearch          = $02;
  hisRedirectChars       = $04;

{ Mouse Defaults }
  omsReverse             = $01;
  omsCursor              = $02;
  omsTrackIn             = $04;
  omsMoveDefaultButton   = $08;
  omsGraphicalCursor     = $10;
  omsUseTwoBitmaps       = $20;
  omsNoShape             = $40;
  omsBigMouse            = $80;

{ Startup/Shutdown Defaults }
  {Startup}
  osuAutoMenu            = $01;
  osuRestoreScrMode      = $02;
  osuKillHistory         = $04;
{$IFDEF DW32KOL}
  osuResetPalette        = $08;
{$ELSE}
{$ENDIF}
{$IFDEF WIN32}
  osuOnlyOneProgramCopy  = $10;
  osuAutoMaximize        = $20;
{$ENDIF}

  {Shutdown}
  osuInactivityExit      = $01;
  osuAutosave            = $02;
  osuBlinking            = $04;
  osuPreserveDir         = $08;
{$IFDEF DW32KOL}
  osuRestorePal          = $10;
{$ENDIF}
{$IFDEF DPMI32}
 {$IFDEF CLOSENOTIFY}
  osuSmartWinBoxClose    = $20;
  osuRestoreDirectory    = $40;
 {$ELSE}
  osuRestoreDirectory    = $20;
 {$ENDIF}
{$ELSE}
 {$IFDEF CLOSENOTIFY}
  osuSmartWinBoxClose    = $20;
  osuRestoreDirectory    = $40;
 {$ELSE}
  osuRestoreDirectory    = $20;
 {$ENDIF}
{$ENDIF}

{$IFDEF DPMI32}
  osuInt28          = $01;
  osuInt2F          = $02;
  osuInt15          = $04;
  osuSleep          = $08;
{$ELSE}
  osuTimeSlice      = $01;
  osuSleep          = $02;
{$ENDIF}

  osaIdleslices     = $01;
  osaReleaseOpen    = $02;
  osaReleaseCopy    = $04;
  osaReleaseArch    = $08;
  osaReleaseFind    = $10;
{$IFDEF FTP}
  osaReleaseFTP     = $20;
{$ENDIF}

{ System Defaults }
  ossEditor        = $01;
  ossViewer        = $02;
  ossUseSysClip    = $04;
  ossShowHidden    = $08;
  ossKeyMacros     = $10;
  ossCheckDDA      = $20;
  {$IFNDEF LINUX}
  ossRemoveCD_RO   = $40;
  ossFlushDsk      = $80;
  ossAutoAsAdmin   = $100;
  {$ELSE}
  ossFlushDsk      = $40;
  ossUsePalVGA     = $80;
  {$ENDIF}

  {Advanced options}
  ossaNoSaveByVMID =    $0001;
  ossaTBAutoSave   =    $0002;
{$IFDEF DPMI32}
  ossaNoWinCheck   =    $0004;
  ossaUnused       =    $0008; {AH 26.12.07 was ossaNoLongNames}
  ossaCopyLimit8m  =    $0010;
  ossaShoWkeyCode  =    $0020;
  ossaEnableGames  =    $0040;
  ossaScrGrbRepZer =    $0080;{AH 29-07-04 Screen Graber: Replace Zeroes}
  ossaChkVesaModes =    $0100;{AH 29-07-04 Check Vesa Modes}
  ossaEnhWildCards =    $0200;{AH 22-09-04 Enhanced Wildcards}
  ossaNewSysErrors =    $0400;{AH  8.12.08 Show OS error messages}
  ossaEnableShot   =    $0800;
  ossaPasteWithStrLen = $1000;
  ossaDisableExec  =    $2000;
{$ELSE}
  ossaCopyLimit8m  =    $0004;
  ossaShowKeyCode  =    $0008;
  ossaEnableGames  =    $0010;
  ossaScrGrbRepZer =    $0020;{AH 29-07-04 Screen Graber: Replace Zeroes}
  ossaEnhWildCards =    $0040;{AH 22-09-04 Enhanced Wildcards}
  ossaNewSysErrors =    $0080;{AH  8.12.08 Show OS error messages}
  ossaEnableShot   =    $0100;
  ossaPasteWithStrLen = $0200;
  ossaDisableExec  =    $0400;
{$IFDEF HAIKU}
  ossaDisableKeyb  =    $0400;
{$ENDIF HAIKU}
{$ENDIF}

  {DriveCheckBoxes}
  ossDirectAccess  = $01;
  ossTree          = $02;
  ossVerify        = $04;
{$IFNDEF LINUX}
  ossNoLFN         = $08;
  ossNoDriveLine   = $10;
{$ELSE}
  ossNoDriveLine   = $08;
{$ENDIF}

  osslRussian      = $00;
  osslEnglish      = $01;

{ TrayIcon Config }
  trayRunInTray      = $01;
  trayMinimizeToTray = $02;
  trayOneInstance    = $04;
  trayAltAdminIco    = $08;
  trayShowNone       = $10;
  trayShowInfo       = $20;
  trayShowWarn       = $40;
  trayShowError      = $80; {G 16-10-2018 TrayIcon config }

{ LFN Setup }
  lfnsColTitles   = $01;
  lfnsCmdLineStr  = $02;
  lfnsFilePanels  = $04;
  lfnsDiskInfo    = $08;
  lfnsPutCmdLine  = $10;
  lfnsFPInfoView  = $20;
  lfnsPutClpbrd   = $40;
  lfnsListfiles   = $80;{AH 1-08-04 SFN/LFN Put into %!1/%2 listfiles}

{ LFN Defaults }
  lfnsCenterExt      = $01;
  lfnsShowExt        = $02;
  lfnsShowSymbolName = $04;
  lfnsShowSymbolExt  = $08;
  {
  lfnsAlignas8_3     = $10;
  }

  colsSmartCase      = $01;
  colsInstead        = $02;
  colsUpperCase      = $04;
  colsNotDouble      = $08;
  colsCenterExt      = $10;
  colsShowExt        = $20;
  colsShowSymbolName = $40;
  colsShowSymbolExt  = $80;
  colsShowBrackets   = $100;
  colsCenterExtDir   = $200;
  colsNaturalSort    = $400;
  colsLeadZDate      = 1;
  colsLeadZTime      = 2;
  colsFullYear       = 4; {was dpFullYear in advance1}
  colsFullTime       = 8; {was dpFullTime in advance1}

  cdnHideCmdLine = $0001;  { DN Misc Information }

{ UU Encode options }
  ckNone   = 0;
  ckEntire = 1;
  ckStd    = 2;
  ckEach   = 3;
  ck64     = 4;

  ckFileTime   =  1;
  ckMapTable   =  2;
  ckStatistic  =  4;
  ckXXEncode   =  8;
  ckMimeEncode = 16;

{ UU Decode options }
  decCheckExistingFiles =  1;
  decDisplayErrors      =  2;
  decKeepBrokenFiles    =  4;
  decMimeDecode         =  8;
  decXXDecode           = 16;

{ Panel sort mode }
  smName         = $00;
  smExt          = $01;
  smSize         = $02;
  smLastWrite    = $03;
  smLastAccess   = $04;
  smCreation     = $05;
  smDescription  = $06;
  smCompressed   = $07;
  smRatio        = $08;
  smGroup        = $09;
  smUnsorted     = $0a;
  smSelected     = $0b;
  smAllocSize    = $0c;
  smNumber       = $0d;
  smInverted     = $0e;
  smDirFirst     = $0f;
  smDirsByName   = $10;
  smReadArch     = $40;
  smGetSelection = $60;
  smCopyUnSelect = $61;
  smUndefined    = $70;
  smCompareDirs  = $80;

{ Compare Directory options }{AH 17-12-03}
  cpdSize        = 1;
  cpdTime        = 2;
  cpdTimeNewer   = 4;
  cpdAttr        = 8;
  cpdContent     = 16;
  cpdShortname   = 32;
  cpdEqual       = 64;
  cpdRecurse     = 128;

{ QuickSearch key }
  pqsAlt  = 0;
  pqsCtrl = 1;
  pqsCaps = 2;
  {$IFDEF LINUX}
  pqsCtrlF = 2;
  {$ELSE}
  pqsMenuF = 3;
  {$ENDIF}

  fmqQuickSearchName = $00001;

{ Default interior for panels, may differ in instances }
  fmiDirLen          = $0001;
  fmiCurrent         = $0002;
  fmiLongName        = $0004;
  fmiTotals          = $0008;
  fmiFree            = $0010;
  fmiHiliteFiles     = $0020;
  fmiIndexSort       = $0040;
  fmiAttrOnSeperator = $0080;
  fmiNewFree         = $0100;
  fmiSortDirection   = $0200;{AH 13-12-03}
  fmiLFNCutRight     = $0400;{AH 13-05-05}
  fmiShowSzDtTm      = $0800;{G  27-10-2018}
  fmiDirFirst        = $1000;
  fmiSelectedFiles   = $2000;{G 14-09-2020}
  {$IFDEF LINUX}
  fmiFlagsOnSeperator= $4000;{G  10-11-2019} //linux fileflags
  fmiDirsByName      = $8000;
  {$ELSE}
  fmiDirsByName      = $4000;
  {$ENDIF}

{ Common panel interior, same for all instances }
  fmsColumnTitles    = $0001;
  fmsDriveLine       = $0002;
  fmsMaskLine        = $0004;
  fmsDivider         = $0008;
  fmsTagChar         = $0010;
  fmsSortIndicator   = $0020;

{ ArchivesSetup }
  fmaRestoreTempFiles  = $0001; {AH 19-01-06 was F4EditInArc}
  fmaEnterExecuteVFS   = $0002;
  fmaMakArcPassiveP    = $0004; {AH  2-03-05 create archive in passive panel}
  fmaOnlyBasicArch     = $0008; {CandyMan 13-12-2021 archive detection setup}

  fmaF3                = $0001;
  fmaEnter             = $0002;

{ File Manager Options for panels }
  fmoAutoChangeDir       =    $00001;
  fmoDragAndDrop         =    $00002;
  fmoBeep                =    $00004;
  fmoSpaceToggle         =    $00008;
  fmoDelErase            =    $00010;
  fmoUseArrows           =    $00020;
  fmoAltDifference       =    $00040;
  fmoCtrlDifference      =    $00080;
  fmoBackGoesBack        =    $00100;
  fmoPreserveDesc        =    $00200;
  fmoTagSometimes        =    $00400;
  fmoKillContainer       =    $00800;
  fmoAlwaysCopyDesc      =    $01000;
  fmoPassiveCursor       =    $02000;
  fmoNewStylePanel       =    $04000;
  fmoShowAttribs         =    $08000;
  fmoDontStartCustom     =    $10000;{AH  5-06-04}
  fmoShowVFSDrvLine      =    $20000;{AH 18-07-04}
  fmoCreateDirUpCase     =    $40000;{AH 25-07-04 UpperCaseFolders}
  fmoUseOldTypeMask      =    $80000;{AH 28-07-04 these 3 are used in GetFileType}
  fmoUseTreeForMask      =   $100000;
  fmoConvMaskToRegExp    =   $200000;
  fmoAltF1F2VFS          =   $400000;{AH 31-07-04 ALT-F1/F2 options}
  fmoAltF1F2QuickDirs    =   $800000;
  fmoAltF1F2ExtQuickDirs =  $1000000;
  fmoPathInListFiles     =  $2000000;{AH  9-08-04 Paths for files in listfiles}
  fmoShowShadows         =  $4000000;{AH 30-09-04 Show Shadows of FilePanel}
  fmoWrapDirHistory      =  $8000000;{AH  4-12-04 Wrap on DirHistory walking}
  fmoAlwaysExecPath      = $10000000;{AH  2-07-05 always start files with path}
  fmoDontQuoteClip       = $20000000;{AH 15-12-05 don't "" LFN on clipboard copy}
  fmoCloseLastFMWin      = $40000000;{AH 18-12-05 Close last FM window}
  fmoDriveLineInfoW      = $80000000;{AH 24-12-05 show window with drive info when changing driveline}

  fm2FileFindCurPnl      = 1 shl  0; {AH 30-06-07 insert found files in current panel}
  fm2ShowHistoryOnChange = 1 shl  1; {Garl 11-06-2020}
{$IFDEF WIN32}
  fm2EraseByCopyToTrash  = 1 shl  2; {CandyMan}
  fm2InsMovesDown        = 1 shl  3; {CandyMan}
  fm2ShowInRootDir       = 1 shl  4; {CandyMan}
  fm2ShowQViewDirInfo    = 1 shl  5; {CandyMan}
  fm2SaveDirectorySel    = 1 shl  6; {CandyMan}
  fm2CompressReadOnly    = 1 shl  7; {CandyMan}
{$ELSE !WIN32}
  fm2InsMovesDown        = 1 shl  2; {CandyMan}
  fm2ShowInRootDir       = 1 shl  3; {CandyMan}
  fm2ShowQViewDirInfo    = 1 shl  4; {CandyMan}
  fm2SaveDirectorySel    = 1 shl  5; {CandyMan}
  fm2CompressReadOnly    = 1 shl  6; {CandyMan}
{$ENDIF WIN32}

{ New manager panel types }
  fdoDriveDrive      = 0;
  fdoInfoDrive       = 1;
  fdoTreeFrive       = 2;
  fdoRightOnly       = 3;

{ DriveInfo data items }
  fdiTitle           = $0001;
  fdiTotals          = $0002;
  fdiVolumeSize      = $0004;
  fdiVolumeFree      = $0008;
  fdiVolumeLabel     = $0010;
  fdiMemAvail        = $0020;
  fdiDIZ             = $0040;
  fdiSerialNo        = $0080; { Rainbow }
  fdiFileSys         = $0100; { Rainbow }
  fdiHostInfo        = $0200; {Garl  3-08-2021}
{$IFDEF DPMI32}
  fdiEMSFree         = $0400;
  fdiXMSFree         = $0800;
{$ENDIF}

{ Confirmations }
  cfSingleErase      = $0001;
  cfMultiErase       = $0002;
  cfEraseSubdir      = $0004;
  cfEraseReadonly    = $0008;
  cfCreateSubdir     = $0010;
  {$IFDEF CDPLAYER}
  cfExitCDconfirm    = $0020;
  cfMouseConfirm     = $0040;
  cfExitConfirm      = $0080;
  cfWinCloseConfirm  = $0100; {  ࠨ   ⨥  }
  cfDenyErase        = $0200;
  cfFileReload       = $0400; {AH11.8.03}
  cfModifyReadOnly   = $0800; {AH12.9.03}
  cfRestoreFiles     = $1000; {AH 21-01-06}
  cfHandleModReload  = $2000; {AH 10-12-06}
  cfDeleteItem       = $4000; // CandyMan 09-06-2020
  cfDisableUndoRedo  = $8000;
  {$ELSE}
  cfMouseConfirm     = $0020;
  cfExitConfirm      = $0040;
  cfWinCloseConfirm  = $0080; {  ࠨ   ⨥  }
  cfDenyErase        = $0100;
  cfFileReload       = $0200; {AH11.8.03}
  cfModifyReadOnly   = $0400; {AH12.9.03}
  cfRestoreFiles     = $0800; {AH 21-01-06}
  cfHandleModReload  = $1000; {AH 10-12-06}
  cfDeleteItem       = $2000; // CandyMan 09-06-2020
  cfDisableUndoRedo  = $4000;
  {$ENDIF}

  cfAsk              = 0;
  cfYes              = 1;
  cfNo               = 2;

{ Regular Expressions Setup }
  reRegExIsDefault   = 1;

{ Name Completion Setup}
  nchkNone           = 0;
  nchkAlt            = 1;
  nchkCtrl           = 2;
  nchkAlt2           = 3;
  nchkCtrl2          = 4;
  nchkCtrlSpace      = 5;
  nchkTab2           = 6;

  ncopNameOptions     = $0001;
  ncopKeywordOptions  = $0002;
  ncopAltDirComp      = $0004;
  ncopKeywordFromFile = $0008;

{ Operating System Setup }
  {these options are now taken from vpsyslow.tSysOptions(), see vpsyslow.so*}
  {previously was os*}
//{$IFDEF LINUX}
//  osUseVCSA            = 1;
//  osUseG1Charset       = 2;
//  osUseUTF             = 4;
//  osFixVCSACursorBug   = 8;
//{$ENDIF}

{ Keyboard Setup }
  kbdUseWordStarCursor = $00000001;
  kbdSwitchHomeEndPage = $00000002;
  kbdClearAltKeyChar   = $00000004;
  kbdCallOldIRQ1       = $00000004; // = 4

{ Informations }
  InNolevelsinfo     = $0001;
  InNoDelay          = $0002;

{ Column data items }
  psShowSize     = $0001;
  psShowDate     = $0002;
  psShowTime     = $0004;
  psShowDir      = $0008;
  psShowDescript = $0008;
  psShowPacked   = $0008;
  psShowRatio    = $0010;
  psShowLongDesc = $0010;

{ FTP Options }
  ftpAnonymous  =  1;
  ftpPassive    =  2;
  ftpWINCharset =  4; { ZakkeR: Insert win charset option }

{$IFDEF MODEM}
{ Terminal emulation }
  emTTY     = 0;
  emANSIBBS = 1;
  emANSI    = 2;
  emVT52    = 3;
  emVT102   = 4;

{ Terminal Options }
  toENTERLF          = $0001;
  toCTRLCLS          = $0002;
  toLocalEcho        = $0004;
  toAutoZModem       = $0008;
  toInsertMode       = $0010;
  toCheckDCD         = $0020;
  toConnectSnd       = $0040;
  toCaptureCtrls     = $0080;

  ttDirectory        = 1;
  ttExec             = 2;
  ttArc              = 3;
  ttCust1            = 4;
  ttCust2            = 5;
  ttCust3            = 6;
  ttCust4            = 7;
  ttCust5            = 8;
  ttCust6            = 9;
  ttCust7            = 10;
  ttCust8            = 11;
  ttCust9            = 12;
  ttCust10           = 13;
{$ENDIF}

{ Calculator }
  coDec              = 0;
  coHex              = 1;
  coBin              = 2;
  coOct              = 3;
  coExp              = 4;
  coTime             = 5;
  coRom              = 6;
  coSys              = 7;
  coValid            = [coDec, coHex, coBin, coOct, coExp, coSys, coTime, coRom];

{ Editor History }
  hsDiskEdit     = 100;
  hsFindMask     = 109;
  hsViewFind     = 110;
  hsFindText     = 110;
  hsSelectBox    = 111;
  hsFileCopyName = 112;
  hsLongCopy     = 113;
  hsEditOpen     = 114;
  hsEditSave     = 115;
  hsEditPasteFrom= 116;
  hsFileMask     = 117;
  hsFindWhat     = 118;
  hsRenameFil    = 119;

  {$IFDEF FTP}
  hsServer       = 165;
  {$ENDIF}

  hsScanDirs     = 120;
  hsLoadSheet    = 121;
  hsGotoCell     = 122;
  hsFindCellPattern = 123;
  hsReplacePattern  = 124;
  hsColors       = 125;
  hsExtract      = 126;
  hsFBBCopy      = 127;
  hsCustoms      = 128;
  hsdbSearch     = 129;
  hsImportPhones = 130;
  hsMakeDir      = 131;
  hsInputParams  = 132;
  hsPrintOut     = 133;
  hsTetris       = 134;
  hsManualPhone  = 135;
  hsCalcLine     = 136;
  hsArcFiles     = 137;
  hsEditDesc     = 138;
  hsFindAfter    = 139;
  hsFindBefore   = 140;
  hsNewVariable  = 141;
  hsExecDOSCmd   = 142;
  hsMakeList     = 143;
  hsEditHistory  = 144;
  hsOpenXLT      = 145;
  hsEditDBF      = 146;
  hsUUEncode     = 147;
  hsUUDecode     = 148;
  hsUULines      = 149;
  hsMakeMsg      = 150;
  hsMakeListHeader  = 151;
  hsMakeListFooter  = 152;
  hsAdvOpt       = 153;
  hsFTPDow       = 154;
  hsFormatLabel  = 155;
  hsWarn         = 156;
  hsFBBCopySize  = 157;
  hsFBBCopyNum   = 158;
  hsSetFilesize  = 159;    { AH27.8.03 }
  hsSetFilesizeChar = 160; { AH27.8.03 }
  hsFillArea     = 161;    { AH27.8.03 }
  hsFillAreaChar = 162;    { AH27.8.03 }
  hsInsRemCount  = 163;    { AH9.9.03 }
  hsChangeBase   = 164;    { AH5.10.03 }
  hsIgnoreMask   = 166; { ZakkeR: exclude file mask }
  hsFindExclMask = 167;    {AH  5-07-07 File Find exclude file mask}
  hsGotoAddress  = 168;
  hsAssemble     = 169;
  hsWriteBlock   = 170;
  hsWriteOffs    = 171;
  hsWriteSize    = 172;
  hsFillBlock    = 173;
  hsAppendSize   = 174;
  hsAppendFill   = 175;
  hsDeleteSize   = 176;
  hsSaveScreen   = 177;
  hsHNFind       = 178;
  hsServerName   = 179;    {G 11-10-2018 server}
  hsUserName     = 180;    {G 11-10-2018 username}
  hsHFFind       = 181;
  hsPrompt       = 182;
  hsLinks        = 183;    {G 17-12-2019 symlinks and hardlinks}
  hsTopic        = 184;

  hsDictFind     = 185;
  hsOpenDict     = 186;
  hsScanDict     = 187;
  hsImportFont   = 188;
  hsInsertString = 189;
  hsConsidered   = 190;
  hsHTMLFind     = 191;
  hsCPUSaved     = 192;
  {$IFDEF OS2}
  hsEditEALongname = 193;
  hsCreateWPSObject = 194;
  {$ENDIF}
  hsChangeCRLF   = 195;
  hsGoToCol      = 196;
  hsDownload     = 197;
  hsContText     = 198;

  cmPanelAddNotify   = 61996;
  cmPanelDelNotify   = 61997;
  cmRereadDirRight   = 61998;
  cmRereadDirLeft    = 61999;

  cmReverseString    = 62000;
  cmChangeCaseString = 62001;
  cmDelMultiSpc      = 62002;
  cmReverseWord      = 62003;// = cmReverseString    + 3
  cmChangeCaseWord   = 62004;// = cmChangeCaseString + 3
  cmDelAllSpc        = 62005;
  cmDelAllSpcNoQuote = 62006;
  cmAdvFormat        = 62007;
  cmPacMan           = 62008;
  cmChExtScreenMode  = 62009;
  cmEditExtModeFile  = 62010;
  cmFileCompare      = 62011;
  cmCompareFile      = 62012;
  cmTogglePaths      = 62013;
  cmDelAllContains   = 62014;
  cmDelAllNoContains = 62015;

  cmMenuComboBox     = 62100;   // 256 Items (..62356)
  cmFirstDisk        = 62356;   // 256 Items (..62512)

  cmCursor      = 63298;
  cmSwitchHelp  = 63299;
  cmBackItem    = 63300;
  cmPrevItem    = 63301;
  cmNextItem    = 63302;
  cmColors      = 63303;

  cmException   = 65398;
  cmDecoHistory = 65399;

  cmDecodePhyDsk  = 65497;
  cmDecodeLogDsk  = 65498;
  cmDecodeMemory  = 65499;

  cmCrLf          = 65500;
  cmCr            = 65501;
  cmLf            = 65502;
  cmLfCr          = 65503;
  cmMixed         = 65504;
  cmNULL          = 65505;
//
  cmBigCalculator = 65506;
  cmGetCurFName   = 65507;
  cmReplaceAgain  = 65508;
//
  cmGoTo          = 65509;
  cmLineFeed      = 65510;
  cmDecode        = 65511;
  cmRandomXX      = 65512;
//
  cmEdit          = 65513;
  cmAssemble0     = 65514;
  cmAssemble1     = 65515;
  cmAssemble2     = 65516;
//
  cmNegXX         = 65517;
  cmNotXX         = 65518;
  cmAddXX         = 65519;
  cmSubXX         = 65520;
//
  cmUpdate        = 65521;
  cmSafeFill      = 65522;
  cmFillBlock     = 65523;
  cmGetBlock      = 65524;
  cmInsBlock      = 65525;
  cmPutBlock      = 65526;
  cmDelBlock      = 65527;
  cmAppend        = 65528;
  cmInsBytes      = 65529;
  cmDelBytes      = 65530;
  cmUndoAll       = 65531;
  cmTrunc         = 65532;
//
  cmGoToAddress   = 65533;
  cmChangeValue   = 65534;

// Command codes
  cmNothing       = 65535;

{ Standard command codes }{ Disable/EnableCommands works with Bytes only }
  cmValid             = 0;
  cmQuit              = 1;
  cmQuitForced        = 11051; {Close open windows and exit}
  cmError             = 2;
  cmMenu              = 3;
  cmClose             = 4;
  cmZoom              = 5;
  cmMinimize          = 46;
  cmMaximize          = 47;
  cmResize            = 6;
  cmNext              = 7;
  cmPrev              = 8;
  cmHelp              = 9;
  cmReset             = 10;
  cmCenter            = 12116; {Center a view}

{ Alarm Clock / Highlight groups}
  cmModifyItem = 0;
  cmNewItem    = 2;
  cmDeleteItem = 3;
  cmNewItemPos = 12;

{ TDialog standard commands }
  EndModalCommands    = [10..19, 31..35];
  cmOK                = 10; {=cmAll}
  cmCancel            = 11;
  cmYes               = 12;
  cmNo                = 13;
  cmDefault           = 14;
  cmSkip              = 15;
  cmTest              = 16;
  cmGotoEntryPoint    = 17; {AH19.7.03 ViewHeader codes}
  cmGotoNewExeHdr     = 18;
  cmGotoImageStart    = 19;
  cmViewNewExeHdr     = 31;
  cmSaveExeHdr        = 32;
  cmGotoOverlayStart  = 33;
  cmViewSections      = 34;
  cmShowDirectories   = 35;

  cmCopysDates        = cmSaveExeHdr;
  cmPasteDates        = cmViewNewExeHdr;

{ Application command codes }
  cmCut               = 20;
  cmCopy              = 21;
  cmPaste             = 22;
  cmUndo              = 23;
  cmRedo              = 30;
  cmClear             = 24;
  cmTile              = 25;
  cmCascade           = 26;

{ Open/Save commands }
  cmOpen              = 27;
  cmSave              = 28;
  cmSaveAll           = 29;

{ Standard messages }
  cmReceivedFocus     = 50;
  cmReleasedFocus     = 51;
  cmCommandSetChanged = 52;

{ TScrollBar messages }
  cmScrollBarChanged  = 53;
  cmScrollBarClicked  = 54;

{ TWindow select messages }
  cmSelectWindowNum   = 55;

{ TListViewer messages }
  cmListItemSelected  = 56;

{ TDialog messages }
  cmRecordHistory     = 60;

{ TGroup messages }
  cmRedrawForce       = 3072; {AH 17-12-05 signal RedrawForced to TGroups}

{ FileViewer Commands }{AH18.7.03}
  ViewerCommands    = [100..120]-[119];
  cmUnWrap          = 100;
  cmAsmBits         = 101;
  cmViewHeader      = 102;
  cmGotoCell        = 103;
  cmInitXX          = 104;
  cmAndXX           = 105;
  cmOrXX            = 106;
  cmXorXX           = 107;
  cmPutXX           = 108;
  cmNot             = 109;
  cmNop             = 110;
  cmInc             = 111;
  cmDec             = 112;
  cmSetFileSize     = 113;
  cmFillArea        = 114;
  cmInsertBytes     = 115; {AH4.9.03}
  cmRemoveBytes     = 116;
  cmShowAll         = 117; {AH1.10.03}
  cmChangeBase      = 118; {AH5.10.03}

{ Editor Commands }
  EditorCommands    = [120..149, 240..242];// CandyMan
  cmBlockRead       = 120;
  cmBlockWrite      = 121;
{  cmBlockPrint      = 122; unused}
  cmFJustify        = 123;
  cmFCenter         = 124;
  cmFLeft           = 125;
  cmFRight          = 126;
  cmSortBlock       = 127;
  cmSortBlockRev    = 149;{AH 14-12-03 ..and we're out of commands}
  cmCalcBlock       = 128;
  cmCopyBlock       = 129;
  cmMoveBlock       = 130;
  cmHideBlock       = 131;
  cmUpcaseBlock     = 132;
  cmLocaseBlock     = 133;
  cmCapitalizeBlock = 134;
  cmIndentBlock     = 135;
  cmUnIndentBlock   = 136;
  cmRusEngConv      = 137;
  cmChangeCaseBlock = 138;
  cmPlayMacro0      = 139; {AH21.11.03}
  cmPlayMacro1      = 140;
  cmPlayMacro2      = 141;
  cmPlayMacro3      = 142;
  cmPlayMacro4      = 143;
  cmPlayMacro5      = 144;
  cmPlayMacro6      = 145;
  cmPlayMacro7      = 146;
  cmPlayMacro8      = 147;
  cmPlayMacro9      = 148;
  cmReverseBlock    = 240;// CandyMan
  cmMoveBlockUp     = 14000;
  cmMoveBlockDown   = 14001;
  cmMoveBlockLeft   = 14002;
  cmMoveBlockRight  = 14003;
  cmCommentBlock    = 14004;{AH 25-12-2004 Block commenting}
  cmUnCommentBlock  = 14005;
  cmCompleteKeyword = 14006;{AH  9-09-06}
  cmUpdateSubTitle  = 14007;

{ Viewer/Editor commands }
  ViewEditCommands  = [119, 150..154, 189..192, 236..239, 254];
{$IFDEF HTMLVIEW}
  cmViewHTML        = 119;{CandyMan 02-12-2021}
{$ENDIF}
  cmViewFile        = 150;{AH 30-11-03}
  cmEditFile        = 151;
  cmViewFileInt     = 153;
  cmEditFileInt     = 154;
  cmViewText        = 189;
  cmViewDump        = 190;
  cmViewHex         = 191;
  cmViewAsm         = 192;
  cmViewDBF         = 236;
  cmViewWKZ         = 237;
  cmViewPKT         = 238;
  cmViewMSG         = 239;
  cmDecodeFile      = 254;
  cmViewFileArc     = 260;
  cmViewFileRes     = 261;

{ Panel Commands }
  PanelCommands     = [119, 150..199, cmViewDBF..cmViewMsg, 254] - [195,196];
  cmCopyFiles       = 155;
  cmTempCopyFiles   = 156;
  cmPanelLongCopy   = 157;
  cmMoveFiles       = 158;
  cmPanelMkDir      = 159;
  cmPanelErase      = 160;
  cmMakeList        = 161;
  cmCompareDir      = 162;
  cmSetFAttr        = 163;
  cmPanelSetup      = 164;
  cmSortBy          = 165;
  cmPanelSelect     = 166;
  cmPanelUnselect   = 167;
  cmPanelInvertSel  = 168;
  cmPanelReread     = 169;
  cmChangeDrive     = 170;
  cmChangeDir       = 171;
  cmSetupColumns    = 172;
  cmPanelPrint      = 173;
  cmPanelArcFiles   = 174;
  cmExtractArchive  = 175;
  cmPanelMakeList   = 176;
  cmListOfDirs      = 177;
  cmCountLen        = 178;
  cmUUEncodeFile    = 179;
  cmUUDecodeFile    = 180;
  cmDirHistory      = 181;
  cmUnpDiskImg      = 182;
  cmSingleDel       = 183;
  cmAdvFilter       = 184;
  cmDirBranch       = 186;
  cmEditDiz         = 187;
  cmPanelSetupX     = 188;

  cmFileFlags       = 193; {G 12-11-2019}
  cmDialPhone       = 194;
  cmWindowManager   = 195;
  cmClearDeskTop    = 196;
  cmCountLenAll     = 197;
  cmChangeRoot      = 198;
  cmPanelUnselectAll= 152;
  cmDriveMenu       = 257; {AH  5-12-04}
  cmChooseColumn    = 258; {AH  3-04-05 Ctrl-[0-9] menu}

{ DblWnd Commands }
  DblWndCommands    = [200..219];
  cmDirTree         = 200;
  cmQuickView       = 201;
  cmSwapPanels      = 202;
  cmHideLeft        = 203;
  cmHideRight       = 204;
  cmChangeLeft      = 205;
  cmChangeRight     = 206;
  cmDiskInfo        = 207;
  cmSwitchOther     = 208;
  cmNetInfo         = 209;
  cmFileInfoI       = 210;
  cmPanelMaximize   = 211;
  cmDriveMenuLeft   = 212; {AH  5-12-04}
  cmDriveMenuRight  = 213;
  cmPanelHoriz      = 214;
  cmPanelHalfS      = 215; // Half Desktop.Size
  cmLoadFontFile    = 216;

{ Phonebook Commands }
  cmPhoneBookMode   = 221;
  cmImportPhones    = 222;
  cmHideInactive    = 224;
  cmCopyPhone       = 225;
  cmInsertPhone     = 226;
  cmDeletePhone     = 227;
  cmEditPhone       = 228;

  cmPalVGA          = 229;

  cmColumnDefaultsDisk = 230;
  cmColumnDefaultsFind = 231;
  cmColumnDefaultsTemp = 232;
  cmColumnDefaultsArch = 233;
  cmColumnDefaultsArvd = 234;
  cmColumnDefaultsProc = 255;
  cmColumnDefaultsServ = 256;
  cmColumnDefaultsNetw = 259;
  cmShutDown           = 235;

  cmSaveText      = 12101;
  cmLoadText      = 12102;
  cmSaveTextAs    = 12103;
  cmSwitchBlock   = 12104;
  cmSwitchIndent  = 12105;
  cmSwitchFill    = 12106;
  cmSwitchBack    = 12107;
  cmSwitchSave    = 12108;

  cmWordEnd       = 12109;
  cmWordLeft      = 12110;
  cmWordRight     = 12111;
  cmDelWordRight  = 12112;
  cmDelWordLeft   = 12113;
  cmScrollUp      = 12114;
  cmScrollDn      = 12115;
  cmDelBackChar   = 12119;
  cmDelChar       = 12120;
  cmSwitchIns     = 12121;
  cmPgUp          = 12122;
  cmPgDn          = 12123;
  cmMoveUp        = 12124;
  cmMoveLeft      = 12125;
  cmMoveRight     = 12126;
  cmMoveDown      = 12127;
  cmBlockStart    = 12128;
  cmBlockEnd      = 12129;
  cmMarkWord      = 12130;
  cmMarkWordAlt   = 12136;{AH  1-03-06 mark word on whitespaces}
  cmMarkLine      = 12131;
  cmMarkAll       = 12132;
  cmMarkParagraph = 12133;{AH 15-01-06 mark current paragraph}
  cmFindNextPara  = 12137;{AH  5-12-06 find next paragraph}
  cmFindPrevPara  = 12143;{AH  5-12-06 find previous paragraph}
  cmRestoreFile   = 12134;{AH 21-01-06 Store file back to it's source}
  cmTab           = 12135;
  cmTabBack       = 12224;{AH  5-01-05 Tab in backward direction}
  cmSpecChar      = 12138;

  cmSearch        = 10608;
  cmSearchAgain   = 10609;
  cmSearchReverse =  3552;
  cmReplace       = 12139;

  cmEnd           = 12140;
  cmEnter         = 12141;
  cmInsLine       = 12142;
  cmLJustify      = 12147;
  cmLCenter       = 12148;
  cmLLeft         = 12149;
  cmLRight        = 12150;
  cmDeltoEOLN     = 12151;
  cmSetMargins    = 12152;
  cmCtrlHome      = 12153;
  cmCtrlEnd       = 12154;
  cmSwitchHighLight = 12155;
  cmGotoLineNumber  = 12156;
  cmSwitchWrap      = 12157;
  cmSwitchHiLine    = 12158;
  cmSwitchHiColumn  = 12159;
  //
  cmUpString         = 12160;
  cmLoString         = 12161;
  cmCapString        = 12162;
  cmUpWord           = 12163; // = cmUpString  + 3
  cmLoWord           = 12164; // = cmLoString  + 3
  cmCapWord          = 12165; // = cmCapString + 3
  //
  cmStartOfFile      = 12225;
  cmEndOfFile        = 12226;
  cmDelToSOL         = 12227;
  cmDelEmptyLines    = 12229;{AH 17-10-07 Editor: Delete empty lines in block}
  cmConvertNumber    = 12230;{AH  6.10.08 convert between number formats}
  cmConvertToDec     = 12231;
  cmConvertToHex     = 12232;
  cmConvertToBin     = 12233;
  cmConvertToOct     = 12234;
  cmConvertToExp     = 12235;
  cmNumberLeft       = 12236;{AH 29.10.08 find numbers, like words}
  cmNumberRight      = 12237;
  cmDelDupLines      = 12238;
  cmDelStrLines      = 12239;
  cmFindFileInArch   = 12240;

  cmSaveTextAsWide   = 12241;
  cmSaveTextAsAsWide = 12242;
  cmForceSaveTextAsWide = 12243;
  cmSaveTextAsUTF8   = 12244;
  cmSaveTextAsAsUTF8 = 12245;
  cmForceSaveTextAsUTF8 = 12246;
  cmSwitchCodePage   = 12247;
  cmAppendString     = 12248;
  cmRemoveFromEnd    = 12249;

  cmInsertTime       = 12166;
  cmInsertDate       = 12167;
  cmMoveBlockStart   = 12168;
  cmMoveBlockEnd     = 12169;
  cmInsertOn         = 12170;
  cmInsertOff        = 12171;
  cmIndentOn         = 12172;
  cmIndentOff        = 12173;
  cmSwitchBlConv     = 12174; {AH21.11.03}
  cmSwitchBrackets   = 12176;
  cmBracketPair      = 12177;
  cmSwitchDrawMode   = 12181;
  cmLoadXlatTable    = 12182;
  cmAdvancePortSetup = 12183;
  cmNavyLinkSetup    = 12184;
  cmLoadXlatMenu     = 12185;
  cmOpenFileAtCursor = 12186;
  cmEditSPF          = 12187;
  cmSaveINI          = 12188;{AH 17-02-07 loading/saving ini file}
  cmLoadINI          = 12228;
  cmChangeCharCase   = 12189;
  cmSwitchTabReplace = 12190;
  cmEditCrLfMode     = 12191;
  cmEditLfMode       = 12192;
  cmEditCrMode       = 12193;
  cmSwitchKeyMapping = 12194;
  cmSwitchMarksShow  = 12195;

  cmNext2            = 12196; {FileManager}
  cmPrev2            = 12197;
  cmGotoLineNumber2  = 12198; {Editor}
  cmLoadXlatExt      = 12199;
  cmSwitchRightTrim  = 12200; {Editor}
  cmForceSaveText    = 12201; {Editor}
  cmSwitchCrLf       = 12202; {FileViewer}

  cmMoveUp1          = 12203;
  cmMoveLeft1        = 12204;
  cmMoveRight1       = 12205;
  cmMoveDown1        = 12206;

  cmReLoad           = 12207; {FileViewer AH17.7.03}{###}
  cmDummy            = 12208; {AH18.7.03}
  cmViewNewFile      = 12209;
  cmSwitchSmartTabs  = 12210; {Editor AH27.10.03}
  cmSwitchCRLFMode   = 12211; {Editor AH18.11.03}
  cmSwitchUnmarkInsert=12212; {Editor AH19.11.03}
  cmSwitchPersBlocks = 12213; {Editor AH19.11.03}
  cmInsertVersion    = 12215; {AH 27-11-03 editor}
  cmHome             = 12216; {AH 27-11-03 editor}
  cmEditorExecFile   = 12217; {AH 17-01-04 Editor Exec}
  cmSwitchSmartBackIndent = 12218; {AH 18-01-04}
  cmSwitchOverwriteBlocks = 12219; {AH 25-01-04}
  cmCountCharsWords  = 12221; {AH 30-11-2004 Editor/Viewer}
  cmSwitchShowLines  = 12222; {AH  9-12-04 Editor/Viewer}

  cmPlaceMarker0     = 13000;
  cmPlaceMarker1     = 13001;
  cmPlaceMarker2     = 13002;
  cmPlaceMarker3     = 13003;
  cmPlaceMarker4     = 13004;
  cmPlaceMarker5     = 13005;
  cmPlaceMarker6     = 13006;
  cmPlaceMarker7     = 13007;
  cmPlaceMarker8     = 13008;
  cmPlaceMarker9     = 13009;
  cmGoToMarker0      = 13010;
  cmGoToMarker1      = 13011;
  cmGoToMarker2      = 13012;
  cmGoToMarker3      = 13013;
  cmGoToMarker4      = 13014;
  cmGoToMarker5      = 13015;
  cmGoToMarker6      = 13016;
  cmGoToMarker7      = 13017;
  cmGoToMarker8      = 13018;
  cmGoToMarker9      = 13019;

  cmSortBookmarks    = 13020;{AH 16-12-06 sort the bookmarks after their location in the file}
  cmPasteAsUTF8      = 13021;
  cmViewFocus        = 13022;

  cmCopyUnselect     = 10001;
  cmRereadDir        = 10004;
  cmRereadInfo       = 10005;
//  cmPushName         = 10006;
  cmRereadTree       = 10007;
  cmDriveLineRefresh = 10008;{AH 27-10-06 refresh the driveline display}
  cmTree             = 10009;
  cmInsertBlock      = 10014;
  cmEnableView       = 10016;
  cmDisableView      = 10017;
  cmDisableSky       = 10018;
  cmChangeDrv        = 10019;
  cmChangeDrvAbsolute= 10020;{AH 18-12-05 == cmChangeDrv, ignore current dirs}
  cmInsertDrive      = 10021;
  cmMenuOn           = 10022;
  cmMenuOff          = 10023;
  cmExecGrabber      = 10024;
  cmCloseDialer      = 10025;
  cmEnableFileInfoI  = 10026;
  cmDisableFileInfoI = 10027;
  cmReconnect        = 10028;

  cmFindEdit         = 10101;
  cmFindView         = 10102;
  cmFindPrint        = 10103;
  cmFindSortBy       = 10104;
  cmFindMakeList     = 10105;
  cmFindGotoFile     = 10106;

  cmPanelXSelect     = 10203;
  cmPanelXUnselect   = 10204;
  cmPanelCompare     = 10211;
  cmPushFirstName    = 10214;
  cmPushFullName     = 10215;

  cmInsertName      = 10301;
  cmInfoPresent     = 10302;
  cmGetDirName      = 10303;
  cmLocalReread     = 10304;
  cmDlgNotFound     = 10305;

  cmPrepareToDelete = 10401;
  cmChangeDirectory = 10402;
  cmChangeTree      = 10403;
  cmLoadViewFile    = 10404;
  cmGLoadViewFile   = 10405;
  cmLViewFile       = 10406;
  cmChangeDirectoryCmdLine = 10412;
  cmLoadInfoFile    = 10413;

  cmExecCommandLine = 10500;
  cmExecFile        = 10501;
  cmDropped         = 10502;
  cmFindCalculator  = 10503;
  cmFindTree        = 10504;
  cmFindTempDrive   = 10505;
  cmTempDrive       = 10506;
  cmCopyToTemp      = 10508;
  cmFind_Drive      = 10509; { find a specific drive (FTP) }
  cmRemove_Drive    = 10510; { find and remove a specific drive (FTP) }
  cmVFSHandleCmdline= 10511; { AH 28-10-05 VFS Handle the command }
  cmExecFileIgnCmdl = 10512; { AH 26-04-06 exec from within editor}

  cmSystemSetup     = 10600;
  cmChangeColors    = 10601;
  cmExtFileEdit     = 10602;
  cmMenuFileEdit    = 10603;
  cmExternalViewers = 10604;
  cmExternalEditors = 10605;
  cmScreenRest      = 10606;
  cmHexMode         = 10607;
  cmStartup         = 10610;
  cmInterfaceSetup  = 10611;
  cmSaversSetup     = 10612;
  cmChScreenMode    = 10613;
  cmHexMode2        = 10614;

  cmSSortName       = 10801;
  cmSSortExt        = 10802;
  cmSSortSize       = 10803;
  cmSSortTime       = 10804;
  cmSSortUnSort     = 10800;
  cmShowFields      = 10805;
  cmShowMemo        = 10806;
  cmEditDBField     = 10807;
  cmGotoRec         = 10808;
  cmDeleteDBRec     = 10809;

  cmNewTable        = 10901;
  cmChangeWidth     = 10904;
  cmSheetLoad       = 10905;
  cmChangeFormat    = 10906;
  cmInsertLine      = 10907;
  cmDeleteLine      = 10908;
  cmInsertColumn    = 10909;
  cmDeleteColumn    = 10910;
  cmRecalc          = 10911;
  cmGotoError       = 10916;
  cmImportToFile    = 10917;
  cmImportToClip    = 10918;
  cmSaveSheetAs     = 10919;
  cmToggleDescriptions = 10920;
  cmToggleIncMode   = 10921;
  cmToggleDecMode  = 10922; //G 30-12-2019

  cmExtract         = 11000;
  cmSetPassword     = 11001;
  cmArcDelete       = 11002;
  cmArcView         = 11003;
  cmArcTest         = 11004;
  cmTermWrite       = 11005;
  cmTermLog         = 11006;
  cmTermVisible     = 11007;
  cmExtractTo       = 11008;
  cmFullView        = 11009;
  cmArchiveFiles    = 11010;
  cmExecString      = 11011;
  cmExecStringWait  = 11050;{AH  1-03-06 don't detect a GUI program}
  cmReceiveFile     = 11012;
  cmSendFile        = 11013;
  cmGetFileName     = 11014;
  cmShowOutput      = 11015;
  cmUnArchive       = 11016;
  cmCheckArchive    = 11017;
  cmInsertFile      = 11018;
  cmMarkFiles       = 11019;
  cmUnMarkFiles     = 11020;
  cmMarkFile        = 11021;
  cmRChDrive        = 11022;
  cmRViewFile       = 11023;
{$IFDEF REANIMAT}
  cmReanimateFile   = 11024;
{$ENDIF}
  cmNewGame         = 11025;
  cmEraseGroup      = 11026;
  cmPutInClipboard  = 11027;
  cmGetFromClipboard= 11028;
  cmReboundPanel    = 11029;
  cmCopyCollection  = 11030;
  cmSendInitModem   = 11031;
  cmSendModemBreak  = 11032;
  cmReadArchive     = 11033;
  cmRereadForced    = 11034;
  cmMakeForced      = 11035;
  cmFindForced      = 11036;
  cmTouchFile       = 11037;
  cmDoSendLocated   = 11038;
  cmGetUserParams   = 11039;
  cmTreeChanged     = 11040;
  cmCloseFormat     = 11041;
  cmCloseLinked     = 11042;
  cmNewGameP        = 11043;
  cmSetupP          = 11044;
  cmShowHiP         = 11046;
  cmStopP           = 11047;
  cmPitonIncLevel   = 11048;
  cmPutSInClipboard = 11049; {  ப}
  cmHelp2           = 11050;

  { TInputline related }
  cmUpdateHexLine   = 11111;
  cmHexLineEvent    = 11112;
{$IFDEF USE_NEW_HISTORY}
  cmUpdateHistory   = 11113; {AH  2-11-07 support for new History type}
{$ENDIF USE_NEW_HISTORY}

  {  Additional Commands   }
  cmRunAmin         = 11202;

  cmAddVariable     = 11205;
  cmRenVariable     = 11206;
  cmDelVariable     = 11207;

  cmTagData            = 11208;
  cmUntagData          = 11209;
  cmToggleTagData      = 11210;
  cmForceTagData       = 11211;
  cmForceUntagData     = 11212;
  cmSelectAll          = 11213;

  {$IFDEF LINUX}
  cmUndoAllDialog      = 11214;
  {$ENDIF}

  cmSetup              = 19001;
  cmStop               = 19002;
  cmShowHi             = 19004;
  cmSendTerminalString = 19005;
  cmPostHideLeft       = 19006;
  cmPostHideRight      = 19007;
  cmDuplicateLine      = 19008;
  cmSwapLine           = 19009;  {AH 27-06-04 new editor command}
  cmSwapWords          = 19031;  {AH 24-11-06 added}
  cmSwapWordsAlt       = 19032;  {AH 24-11-06 added}
  cmSwapParagraphs     = 19033;  {AH  6.11.08 added}

  { Special Commands }
  cmChangeInactive  = 19010;
  cmMainMenu        = 19011;
  cmAddFilter       = 19012;
  cmGetDirInfo      = 19014;
  cmSinglePrint     = 19015;
  cmSingleAttr      = 19016;
  cmSingleTag       = 19017;
  cmSingleUntag        = 19018;
  cmGetCurrentPosFiles = 19019;
  cmSyncClipOut        = 19020;
  cmSyncClipIn      = 19021;
  cmWindowsPaste    = 19022;
  cmWindowsCopy     = 19023;
  cmWindowsCut      = 19024;{AH 28-11-03}
  cmReleaseFile     = 19026;
  cmFastRename      = 19027;
  cmGetNetInfo      = 19028;
  cmGetFileInfoI    = 19029;
  cmFileOperations  = 19030;{AH  2-03-04}
  cmGoMoku          = 19031;
  cmXMSStat         = 19032;
  cmEMSStat         = 19033;

  { Terminal/ScrollBack }
  cmScrollBack      = 19114;
  cmSBBKill         = 19115;
  cmSBBStore        = 19116;
  cmSBBGrab         = 19117;

  cdPlay            = 19900;
  cdStop            = 19901;
  cdNext            = 19902;
  cdPrev            = 19903;
  cdEject           = 19904;
  cdPause           = 19905;
  cdFFwd            = 19906;
  cdFRew            = 19907;
  cdSetup           = 19908;
  cdDisplay         = 19909;
  cdZoom            = 19910;
  cdMode            = 19911;
  cdOrder           = 19912;
  cdTitle           = 19913;
  cdMix             = 19914;
  cdSong            = 19915;

  cmTextMode        = 1002;
  cmDirMode         = 1003;
  cmFATMode         = 1004;
  cmFixFile         = 1005;
  cmFixDir          = 1006;
  cmFixDrive        = 1007;
  cmFixCluster      = 1008;
  cmFixSector       = 1009;
  cmFixBSec         = 1010;
  cmFix1FAT         = 1011;
  cmFix2FAT         = 1012;
  cmFixRDir         = 1013;

  cmFixBlockWrite   = 240;

  cmOpenFile        = 3001;
  cmOpenWindow      = 3002;
  cmChangeMode      = 3003;
  cmFindFile        = 3004;
  cmCreatePanel     = 3006;
  cmCreateTree      = 3007;
  cmAbout           = 3008;
  cmRefresh         = 3009;
  cmXViewFile       = 3011;
  cmShowUserScreen  = 3012;
  cmFormatDisk      = 3013;
  cmXEditFile       = 3015;
  cmMemoryInfo      = 3016;
  cmMemMap          = 3017;
  cmLoadDesk        = 5434;
  cmSaveDesk        = 5435;
  cmSystemDisk      = 3018;
{$IFDEF REANIMAT}
  cmReanimator      = 3019;
{$ENDIF}
  cmDiskEdit        = 3020;
  cmSetVolumeLabel  = 3021;
  cmCalculator      = 3022;
  cmCalendar        = 27000;
  cmHideShowTools   = 3023;
  cmChangeUserMode1 = 3024;
  cmChangeUserMode2 = 3025;
  cmUserMenu        = 3026;
  cmLocalMenuFileEdit = 3027;
  cmGetName         = 3028;
  cmPhoneBook       = 3030;
  cmStoreColors     = 3031;
  cmLoadColors      = 3032;
  cmHangUp          = 3033;
  cmSetupModem      = 3034;
  cmTerminal        = 3035;
  cmUndial          = 3036;
  cmDemoVersion     = 3037;
  cmTotalReread     = 3038;
  cmCPUInfo         = 3039;
  cmHideWindows     = 3040;
  cmHistoryList     = 3041;
  cmASCIITable      = 3042;
  cmTetris          = 3043;
  cmKillUsed        = 3044;
  cmFMDefaults      = 3045;
  cmEditorDefaults  = 3046;
  cmSetupArchive    = 3047;
  cmUpdateConfig    = 3048;
  cmPrintFile       = 3049;
  cmPrintBlock      = 3075;
  cmHighlightGroups = 3050;
  cmSetupMouse      = 3054;
  cmSetupPrinter    = 3055;
  cmFilePrint       = 3056;
  cmNavyLink        = 3057;
  cmColumnDefaults  = 3058;
  cmRunDemo         = 3059;
  cmEditQuickRun    = 3060;
  cmCmdLineSetup    = 3061;
  cmIsForeSkin      = 3062;
  cmPiton           = 3063;
  cmSaveVideoModes  = 3064;
  cmViewerDefaults  = 3065;
  cmPluginsCnf      = 3066;
  cmDisAsmDefaults  = 3067;
  cmInsertVideoMode = 3068;
  cmResetVideoModes = 3069;
  cmRefreshScrMode  = 3070;
  cmVideoModeChanged= 3071;{AH  8-03-05 signal video mode change to NDN}
  cmEditVideoMode   = 3072;{AH  7-11-06 edit the selected video mode}
  cmResetMouse      = 3073;{AH 18-01-07 reset/reinit the mouse at runtime}
  cmDBFDefaults     = 3074;{Garl 15-07-2007 }
  cmResetClock      = 3076;{AH 30.12.07 reset mouse position}

  cmSameGame        = 3077;
  cmDoCompress      = 3078;
  cmDeCompress      = 3079;

  cmNetworkSetup    = 3080;{Garl 22-10-2018 }
  cm2048            = 3081;{Garl  6-11-2018 }
  cmDirSize         = 3082;
  cmVesaInfo        = 3083;
  cmShot            = 3084;
  cmShotFull        = 3085;
  cmUpDateNDN       = 3086;
  cmAttribTags      = 3087;{Garl 28-04-2020}
  cmArchivesSetup   = 3088;{Garl 17-05-2020}
  cmSetupKeyb       = 3089;
  cmCursorSetup     = 3090;

  cmUpdateArcFile     = 3200;
  cmArchivesFormats   = 3201;

  cmForceRescan       = 3217;
  cmGlobalUserMenu    = 3220;
  cmEditMenu          = 3221;
  cmClearData         = 3222;
  cmSearchAdvance     = 3223;
  cmCountrySetup      = 3224;
  cmSetupConfirmation = 3225;
  cmTerminalDefaults  = 3226;
  cmGetTeam           = 3227;
  cmRegisterGer       = 3228;
  cmRegisterGB        = 3229;
  cmRegisterMol       = 3231;
  cmRegisterNL        = 3232;
  cmRegisterRus       = 3233;
  cmRegisterCCGermany = 3234;
  cmRegisterCCGB      = 3235;
  cmOpenSmartpad      = 3236;
  cmTetrisPreview     = 3237;
  cmTetrisIncLevel    = 3238;
  cmPlayCD            = 3239;
  cmEnvEdit           = 3240;
  cmEditHGL           = 3241;
  cmSingleCopy        = 3242;
  cmSingleRename      = 3243;
  cmExecuteDOScmd     = 3244;
  cmFMSetup           = 3246;
  cmDriveInfoSetup    = 3247;
  cmHideCmdLine       = 3248;
  cmRecountDirs       = 3249;
  cmDiskDesc          = 3250;
  cmInformationPanels = 3251;
  cmLFNSetup          = 3252;
  cmGlobalSetup       = 3253;
  cmIniEdit           = 3254;
  cmChangeLanguage    = 3255;
  cmMiscSetup         = 3256;
//  cmRegExSetup        = 3257;
  {$IFDEF DW32}
  cmOpenInExplorer    = 3258;
  {$ENDIF}
  {$IFDEF OS2}
  cmOpenInExplorer    = 3258;
  {$ENDIF}
  {$IFDEF CONTEXTMENU}
  cmOpenContextMenu   = 3259;
  {$ENDIF}
  cmSfnLfnNames       = 3260; {G 29-09-2020 Ctrl-N switch display name mode}

  cmLookForPanels     = 3550; {   ? }
  cmFirstTimePanel    = 3551; {  , ᫨    }
  cmEditHistory       = 3553;
  cmViewHistory       = 3554;
  cmDelHistories      = 3558;
  cmLoadHistories     = 3561; {AH  1-10-07}
  cmSaveHistories     = 3562;
  cmOpenClipBoard     = 3555;
  cmEmptyClipBoard    = 3559; {AH 23-02-06 empty the system clipboard}
  cmShowTimeInfo      = 3556;
  cmAlarmClock        = 3557;
  cmStartTimeInfo     = 3560; {AH  5-10-06 start and show via messages}
  cmRedrawSystray     = 3563; {G 16.10.2018}

  cmSetValue          = 10000;
  cmSetError          = 10001;
  cmCalcValue         = 10002;
  cmCopyClip          = 10003;

  cmGetPtr1           = 23000;
  cmGetPtr2           = 23001;

{ R - Commands  }
  cmRFormat           = 24000;
  cmNewStrColl        = 24001;
  cmGetCmpNfo         = 24418;
  cmRSearchAdvance    = 24123;

  cmSelectMenuCommands = 30000;
  MoreCommand          = 30998;
  NoneCommand          = 30999;

{ QuickDir commands }
  cmQuickChange1     = 11300;
  cmQuickChange2     = 11301;
  cmQuickChange3     = 11302;
  cmQuickChange4     = 11303;
  cmQuickChange5     = 11304;
  cmQuickChange6     = 11305;
  cmQuickChange7     = 11306;
  cmQuickChange8     = 11307;
  cmQuickChange9     = 11308;
  cmQuickChange0     = 11309; {Garl - external QuickDirsChange flag}
  cmQuickChangeMax   = 11399;
  cmEditExtQuickDirs = 11400;

  cmGetCurrentWord   = 11420;

  cmHelpContents     = 11421;
  cmHelpIndex        = 11422;
  cmHelpTopicSearch  = 11423;
  cmHelpPrevTopic    = 11424;
  cmHelpFiles        = 11425;

  cmPrevTopic        = 11426;
  cmHelpFilesChanged = 11427;
  cmAddItem          = 11428;
  cmEditItem         = 11429;
  cmDelItem          = 11430;
  cmShowItem         = 11431;
  cmHideItem         = 11432;
  cmCharLeft         = 11433;
  cmCharRight        = 11434;
  cmLineStart        = 11435;
  cmLineEnd          = 11436;
  cmWindowStart      = 11437;
  cmWindowEnd        = 11438;
  cmLineUp           = 11439;
  cmLineDown         = 11440;
  cmPageUp           = 11441;
  cmPageDown         = 11442;
  cmTextStart        = 11443;
  cmTextEnd          = 11444;

  cmSetMaximalMode  = 11479;

  cmPanelSHighlight = 11480;
  cmPanelUHighlight = 11481;
  cmPanelSName      = 11482;
  cmPanelUName      = 11483;
  cmPanelExcSName   = 11484;
  cmPanelExcUName   = 11485;
  cmPanelSExt       = 11486;
  cmPanelUExt       = 11487;
  cmPanelExcSExt    = 11488;
  cmPanelExcUExt    = 11489;

  cmNewCMD     = 11490;

  cmPanelSaveSelect = 11491;
  cmPanelRestSelect = 11492;

  cmTaskList   = 11493;
  cmCloseIcon  = 11494;
  cmPopMenu    = 11495;
  cmFontsSetup = 11496;
  cmEmptyRecycle = 11497;
  cmHN        = 11498;

  cmCrux      = 11499;
  cmCruxTimer = 11500;
  cmCruxNew   = 11501;
  cmCruxSetup = 11502;
  cmCruxTop   = 11503;
  cmCruxPause = 11504;
  cmSystemInfo = 11505;
  cmCalcHash  = 11506;

  cmPuzzle    = 11601;
  cmPuzzleNew = 11602;
  cmGameRestart = 11603;
  cmGamePause = 11604;
  cmGameSetup = 11605;
  cmFieldBase = 11620; // next 25 commands are reserved

{ Logon server user commands}
  cmInputServer      = 11700;
  cmInputLoginPsw    = 11701;
  cmInputServLgPsw   = 11702;
  cmInputServLgPsw1  = 11703;
  cmInputLoginPsw1   = 11704;

  cmIdentify    = 15000;
  cmSetID       = 15001;
  cmFieldError  = 15002;

  cmStatusUpdate = 15010;

  cmMarkStart   = 16000;
//
  cmFontSize06  = 16000;
  cmFontSize07  = 16001;
  cmFontSize08  = 16002;
  cmFontSize09  = 16003;
  cmFontSize10  = 16004;
  cmFontSize11  = 16005;
  cmFontSize12  = 16006;
  cmFontSize13  = 16007;
  cmFontSize14  = 16008;
  cmFontSize15  = 16009;
  cmFontSize16  = 16010;
  cmFontSize17  = 16011;
  cmFontSize18  = 16012;
  cmFontSize19  = 16013;
  cmFontSize20  = 16014;
  cmFontSize21  = 16015;
  cmFontSize22  = 16016;
  cmFontSize23  = 16017;
  cmFontSize24  = 16018;
  cmFontSize25  = 16019;
  cmFontSize32  = 16020;
//
  cmMarkEnd     = 17000;
  cmDoubleScan  = 17001;

  cmInsertDict  = 17002;
  cmDeleteDict  = 17003;
  cmImportDict  = 17004;
  cmImportText  = 17005;
//
  cmCWMania     = 17006;
  cmMaska       = 17007;
  cmAnagram     = 17008;
  cmUsePCRE     = 17009;
  cmPalindrom   = 17010;
//
  cmSlash               = 17011;
  cmStar                = 17012;
  cmPlus                = 17013;
  cmQuestion            = 17014;
  cmLParenthesis        = 17015;
  cmRParenthesis        = 17016;
  cmLBracket            = 17017;
  cmRBracket            = 17018;
  cmLNextBracket        = 17019;
  cmRNextBracket        = 17020;
  cmColon               = 17021;
  cmDollar              = 17022;
  cmPoint               = 17023;
  cmPipe                = 17024;
  cmSpec                = 17025;
//
  cmA                   = 17026;
  cmC                   = 17027;
  cmE                   = 17028;
  cmL                   = 17029;
  cmN                   = 17030;
  cmO                   = 17031;
  cmS                   = 17032;
  cmX                   = 17033;
  cmZ                   = 17034;
//
  cmAA                  = 17035;
  cmCC                  = 17036;
  cmEE                  = 17037;
  cmLL                  = 17038;
  cmNN                  = 17039;
  cmOO                  = 17040;
  cmSS                  = 17041;
  cmXX                  = 17042;
  cmZZ                  = 17043;
//
  cmInterrupt           = 17044;
  cmMemDetail           = 17045;
  cmDevDetail           = 17046;
  cmVecDetail           = 17047;
//
  cmFilters             = 17048;
//
  cmAdvFilter0          = 17049;
  cmAdvFilter1          = 17050;
  cmAdvFilter2          = 17051;
//
  cmGlobal              = 17052;
  cmGoToEx              = 17053;
  cmFileProperties      = 17054;
  cmToogleCmdLine       = 17055;
  cmBeast               = 17056;
  cmPanelWipe           = 17057;
  cmShowResult          = 17058;
  cmDriveInfo           = 17059;
  cmAnalogClock         = 17060;
  cmSwitchAutoSpaces    = 17061;
  cmGo1stNonBlank       = 17062;
  cmClearSelList        = 17063;
  cmInsertUsingFont     = 17064;
  cmAltCalendar         = 17065;
  cmScreenKeyb          = 17066;
  cmWebsiteNDN          = 17067;
  cmDescInfo            = 17068;
  cmMinesweeper         = 17069;
  cmToggleMarkMode      = 17070;
  cmSquares             = 17071;
  cmSaveCPU             = 17072;
  cmSetEALongname       = 17073;
  cmCreateWPSObject     = 17074;
  cmSetFAttrSubDirs     = 17075;
  cmLineEndToDos        = 17076;
  cmLineEndToMac        = 17077;
  cmLineEndToUnx        = 17078;
  cmActualizeTimer      = 17079;
  cmCutInv              = 17080;
  cmShuffle             = 17081;
  cmReHighLite          = 17082;
  cmSelectSyntax        = 17083;
  cmRevPosLines         = 17084;
  cmSwitchFreezeText    = 17085;
  cmEncryptText         = 17086;
  cmDecryptText         = 17087;
  cmToggleSecurity      = 17088;
  cmSaveEncrypted       = 17089;
  cmOpenEncrypted       = 17090;
  cmGotoColNumber       = 17091;
  cmUndoDisable         = 17092;
  cmUndoEnable          = 17093;
  cmChangeCaseChrRan    = 17094;
  cmChangeCaseStrRan    = 17095;
  cmChangeCaseWrdRan    = 17096;
  cmChangeCaseBlkRan    = 17097;
  cmSortBlockIgn        = 17098;
  cmSortBlockIgnRev     = 17099;
  cmCalculatorRPN       = 17100;
  cmInsertCoolText      = 17101;
  cmQuoteRight          = 17102;
  cmQuoteLeft           = 17103;
  cmSpeaker             = 17104;
  cmInternetDownload    = 17105;
  cmPlugins             = 17106;
  cmSameFolder          = 17107;
  cmFolderSame          = 17108;
  cmFindPlugins         = 17109;
  cmUserCharRight       = 17110;
  cmUserCharLeft        = 17111;
  cmGetCurrentPanel     = 17112;
  cmGetCurPanelList     = 17113;
  cmJumpCurrentItem     = 17114;
  cmGetsCurrentItem     = 17115;
  cmMemory              = 17116;
  cmClusterChanged      = 17117;
  cmMatrix              = 17118;
  cmLife                = 17119;
  cmFlatView            = 17120;
  cmDarkColor           = 17121;
{ Game Menu }
  cmMoveUndo            = 17122;
  cmStopMove            = 17123;
{ Edit menu }
  cmRedoMove            = 17124;
  cmComputerMove        = 17125;
  cmEnterMove           = 17126;
  cmShowHint            = 17127;
{ Options Menu }
  cmSettings            = 17128;
{ Game control }
  cmSubmitMove          = 17129;
  cmMovePiece           = 17130;
  cmUndoMove            = 17131;
  cmClearBoard          = 17132;
  cmFindPiece           = 17133;
  cmGameOver            = 17134;
  cmRegisterSave        = 17135;
  cmTimeOptChg          = 17136;
{ Pawn Promotion }
  cmQueen               = 17137;
  cmRook                = 17138;
  cmBishop              = 17139;
  cmKnight              = 17140;
{ Chess }
  cmChess               = 17141;
//
  cmConverter           = 17142;
  cmDecoderHexMode      = 17143;
  cmGoToSpecialPath     = 17144;
  cmGoToEnvVariable     = 17145;
  cmFindOpenFiles       = 17146;
  cmMaxitGame           = 17147;

{ Help Contexts }

  hcNew       = $FF01;
  hcOpen      = $FF02;
  hcSave      = $FF03;
  hcSaveAs    = $FF04;
  hcSaveAll   = $FF05;
  hcChangeDir = $FF06;
  hcDosShell  = $FF07;
  hcExit      = $FF08;

  hcUndo      = $FF10;
  hcCut       = $FF11;
  hcCopy      = $FF12;
  hcPaste     = $FF13;
  hcClear     = $FF14;

  hcTile      = $FF20;
  hcCascade   = $FF21;
  hcCloseAll  = $FF22;
  hcResize    = $FF23;
  hcZoom      = $FF24;
  hcNext      = $FF25;
  hcPrev      = $FF26;
  hcClose     = $FF27;

{ copied from views.pas }

  ofSelectable  = $0001;
  ofTopSelect   = $0002;
  ofFirstClick  = $0004;
  ofFramed      = $0008;
  ofPreProcess  = $0010;
  ofPostProcess = $0020;
  ofBuffered    = $0040;
  ofTileable    = $0080;
  ofCenterX     = $0100;
  ofCenterY     = $0200;
  ofCentered    = $0300;
  ofValidate    = $0400;
  ofVersion     = $3000;
  ofVersion10   = $0000;
  ofVersion20   = $1000;
  ofSecurity    = $0800;
  ofUppercase   = $4000; {AH  9-04-05 Inputlines UpCase input automatically}
  ofDontStore   = $8000;
  of3DFramed    = $10000;
  ofDontClearSelectable = $20000;
  ofVScrollBar  = $40000;
  ofHScrollBar  = $80000;
  ofAScrollBar  = $C0000;
  ofSkipCluster = $100000;
  ofMoveItems   = $200000;
  ofHideModify  = $400000;
  ofAutoGrow    = $800000; // auto grow scrolldialog if possible
  ofInvisible   = $1000000;// icon is invisible
  ofHasNumberID = $2000000;// TView has identification number

  dfRequired    = $0001; // Field entry is required
  dfRJustify    = $0002; // Trim and Right justify result
  dfLJustify    = $0004; // Trim and Left justify result
  dfTrim        = $0008; // Trim all pad chars from result
  dfHide        = $0010; // Password input
  dfDefaults    = $0020; // Use default values if available

// TMenuItem Disabled Flags
  dfDisabled            = $01;
  dfDoNotFreeSubMenu    = $02;
  dfAllowChangeDefault  = $04;
  dfExecDefault         = $08;
  dfParam               = $10;
  dfSubMenu             = $20;
  dfReserved            = $3F;
  dfChangeMenu          = $40;
  dfMenuBit             = $80;

// TWindow Flags masks
  wfMove  = $01;
  wfGrow  = $02;
  wfClose = $04;
  wfZoom  = $08;
{$IFDEF MINIMIZE}
  wfMin   = $10;
{$ENDIF}
  wfUndo  = $20;

type
{ Archiver Setup Options }
  ArchiverSetupOptions = Set of (
   {archiver handles LFN}              {$IFNDEF LINUX} asoLFN, {$ENDIF}
   {drop archiver command to cmdline}  asoShowCmdString,
   {redirect the archiver output}      asoRedirectPack,
                                       asoRedirectUnPack,
   {force usage of / instead of \}     {$IFNDEF LINUX} asoForceUnixPathSep, {$ENDIF}
   {don't separate options with space} asoDontSeparateOptions
                                );
{ Hints }
  THntIdx = (
    hnEmpty,                    // Must be 1st
    hnSystem,
    hnUpdate,
    hnWebsiteNDN,
    hnAbout,
    hnChangeLanguage,
    hnRefreshDisplay,
    hnResetMouse,
    hnResetClock,
    hnScreenRest,
    hnActualizeTimer,
    hnExecGrabber,
    hnShotMenu,
    hnShot,
    hnShotFull,
    hnShowUserScreen,
    hnShowOutput,
    hnOpenSmartpad,
    hnTrashcan,
    hnClipboardOper,
    hnOpenClipBoard,
    hnEmptyClipBoard,
    hnAlarmClock,
    hnDoubleScan,
    hnLoadFontFile,
    hnSwitchFont,
    hnVideoModes,
    hnChangeMode,
    hnChangeMode1,
    hnChangeMode2,
    hnChangeModeList,
    hnExtVidMode,
    hnSetMaximalMode,
    hnGames,
    hnTestExc,
    hnFile,
    hnView,
    hnViewFile,
    hnViewText,
    hnViewDump,
    hnViewHex,
    hnViewAsm,
    hnViewDBF,
    hnViewWKZ,
    hnViewHTML,
    hnDecodeFile,
    hnViewFileInt,
    hnEdit,
    hnEditFile,
    hnEditFileInt,
    hnXEditFile,
    hnDecode,
    hnDecodeLogDsk,
    hnDecodePhyDsk,
    hnDecodeMemory,
    hnFindFile,
    hnCopyFIles,
    hnMoveFiles,
    hnSingleFile,
    hnSingleCopy,
    hnSingleMove,
    hnSingleDel,
    hnFastRename,
    hnToArchive,
    hnFmArchive,
    hnSplit,
    hnPrintFile,
    hnPanelMkDir,
    hnPanelErase,
    hnPanelWipe,
    hnSetFAttr,
    hnSetFAttrSubDirs,
    hnCompareFile,
    hnFileFlags,
    hnFileOperations,
    hnFileProperties,
    hnCoDeCompress,
    hnDoCompress,
    hnDeCompress,
    hnEnDeCode,
    hnUUEncodeFile,
    hnUUDecodeFile,
    hnEditDiz,
    hnCalcHash,
    hnLineEnd,
    hnLineEndToDos,
    hnLineEndToMac,
    hnLineEndToUnx,
    hnShutDown,
    hnQuit,
    hnReset,
    hnDiskOper,
    hnEmptyRecycle,
    hnFormatDisk,
    hnSetVolumeLabel,
    hnUnpDiskImg,
    hnDriveInfo,
    hnCreateTree,
    hnUtilities,
    hnMemUtils,
    hnMemMap,
    hnMemInfo,
    hnMemInfoDet,
    hnXMS,
    hnEMS,
    hnCPUInfo,
    hnSysInfo,
    hnVESAInfo,
    hnHN,
    hnAnalogClock,
    hnPlayCD,
    hnCalendar,
    hnCWMania,
    hnExecuteDOSCmd,
    hnNewCMD,
    hnScreenKeyb,
    hnOpenContextMenu,
    hnOpenInExplorer,
    hnPhoneBook,
    hnCalculatorRPN,
    hnASCIITable,
    hnBigCalculator,
    hnCalculator,
    hnEnvEdit,
    hnDirSize,
    hnSheetLoad,
    hnTaskList,
    hnUserMenu,
    hnHistory,
    hnDirHistory,
    hnHistoryList,
    hnEditHistory,
    hnViewHistory,
    hnDecoHistory,
    hnLoadHistories,
    hnSaveHistories,
    hnDelHistories,
    hnClearSelList,
    hnPanel,
    hnMakeList,
    hnReadList,
    hnCompareDir,
    hnCountLen,
    hnCountLenAll,
    hnDirBranch,
    hnSetupColumns,
    hnChooseColumn,
    hnPanelSetupX,
    hnSortBy,
    hnPanelFilter,
    hnAdvFilter0,
    hnAdvFilter1,
    hnAdvFilter2,
    hnAdvFilter,
    hnSelection,
    hnPanelSaveSelect,
    hnPanelRestSelect,
    hnChangeDrive,
    hnDriveMenu,
    hnChangeDir,
    hnForceRescan,
    hnListOfDirs,
    hnManager,
    hnCreatePanel,
    hnDirTree,
    hnDiskInfo,
    hnQuickView,
    hnDescInfo,
    hnSwapPanels,
    hnHideLeft,
    hnHideRight,
    hnSwitchOther,
    hnPanelMaximize,
    hnPanelHalfS,
    hnPanelHoriz,
    hnChangeLeft,
    hnChangeRight,
    hnDriveMenuLeft,
    hnDriveMenuRight,
    hnOptions,
    hnConfiguration,
    hnSystemSetup,
    hnGlobalSetup,
    hnFontsSetup,
    hnStartup,
    hnInterfaceSetup,
    hnSetupConfirmation,
    hnCmdLineSetup,
    hnLfnSetup,
    hnMiscSetup,
    hnSaversSetup,
    hnSetupPrinter,
    hnCountrySetup,
    hnSetupMouse,
    hnSetupKeyb,
    hnCursorSetup,
    hnEditorDefaults,
    hnViewerDefaults,
    hnDBFDefaults,
    hnDisAsmDefaults,
    hnNetworkSetup,
    hnChangeColors,
    hnStoreColors,
    hnLoadColors,
    hnFManger,
    hnFMSetup,
    hnDriveInfoSetup,
    hnFMDefaults,
    hnAttribTags,
    hnColumnDefaults,
    hnHighlightGroups,
    hnArchivers,
    hnArchivesFormats,
    hnSetupArchive,
    hnArchivesSetup,
    hnUpdateArcFile,
    hnConfigFiles,
    hnDiskDesc,
    hnIniEdit,
    hnEditSPF,
    hnExtFileEdit,
    hnEditHGL,
    hnEditQuickRun,
    hnExternalViewers,
    hnExternalEditors,
    hnFilters,
    hnEditExtQuickDirs,
    hnEditExtModeFile,
    hnMenuFileEdit,
    hnLocalMenuFileEdit,
    hnSaveINI,
    hnLoadINI,
    hnSaveDesk,
    hnLoadDesk,
    hnWindows,
    hnTile,
    hnCascade,
    hnClearDesktop,
    hnResize,
    hnZoom,
    hnMinimize,
    hnMaximize,
    hnCenter,
    hnNext,
    hnPrev,
    hnNext2,
    hnPrev2,
    hnClose,
    hnWindowManager,
    hnPopMenu,
    hnImport,
    hnHelpContents,
    hnHelpIndex,
    hnHelpTopicSearch,
    hnHelpPrevTopic,
    hnHelpFiles,
    hnWindowHelp,
    hnDictOper,
    hnOpenNewDict,
    hnCloseDict,
    hnHelp,
    hnEditDict,
    hnInsertDict,
    hnDeleteDict,
    hnImportDict,
    hnImportText,
    hnPalindrom,
    hnShowResult,
    hnPasteDict,
    hnCopyDict,
    hnLoadText,
    hnOpenEncrypted,
    hnReload,
    hnOpenFileAtCursor,
    hnFindGotoFile,
    hnEditorExecFile,
    hnSaveText,
    hnSaveTextAs,
    hnForceSaveText,
    hnForceSaveTextAs,
    hnSaveAll,
    hnSaveEncrypted,
    hnPrintBlock,
    hnMainMenu,
    hnCloseText,
    hnUndo,
    hnRedo,
    hnUndoDisable,
    hnUndoEnable,
    hnCut,
    hnCopyText,
    hnPasteText,
    hnBlockWrite,
    hnBlockRead,
    hnClear,
    hnMacros,
    hnSearchText,
    hnSearch,
    hnReplace,
    hnSearchAgain,
    hnSearchReverse,
    hnGotoLineNumber,
    hnGotoColNumber,
    hnSortBookmarks,
    hnPlaceMarker,
    hnGotoMarker,
    hnFJustify,
    hnFRight,
    hnFLeft,
    hnFCenter,
    hnSetMargins,
    hnFindPrevPara,
    hnFindNextPara,
    hnBlockStart,
    hnBlockEnd,
    hnMarkLine,
    hnMarkWord,
    hnMarkWordAlt,
    hnMarkParagraph,
    hnMarkAll,
    hnHideBlock,
    hnMoveBlock,
    hnMoveBlockUp,
    hnMoveBlockDown,
    hnMoveBlockLeft,
    hnMoveBlockRight,
    hnIndentBlock,
    hnUnIndentBlock,
    hnMoveBlockStart,
    hnMoveBlockEnd,
    hnCopyBlock,
    hnUpcaseBlock,
    hnLocaseBlock,
    hnCapitalizeBlock,
    hnChangeCaseBlock,
    hnReverseBlock,
    hnChangeCaseBlkRan,
    hnCommentBlock,
    hnUncommentBlock,
    hnRusEngConv,
    hnSortBlock,
    hnSortBlockRev,
    hnSortBlockIgn,
    hnSortBlockIgnRev,
    hnCutInv,
    hnRevPosLines,
    hnShuffle,
    hnCalcBlock,
    hnDelEmptyLines,
    hnDelDupLines,
    hnDelStrLines,
    hnDelAllContains,
    hnDelAllNoContains,
    hnInsertDate,
    hnInsertTime,
    hnInsertVersion,
    hnInsLine,
    hnDelBackChar,
    hnDelChar,
    hnDelWordLeft,
    hnDelWordRight,
    hnDeleteLine,
    hnDeltoEOLN,
    hnDelToSOL,
    hnDelMultiSpc,
    hnDelAllSpc,
    hnDelAllSpcNoQuote,
    hnSwapLine,
    hnSwapWords,
    hnSwapWordsAlt,
    hnSwapParagraphs,
    hnDuplicateLine,
    hnSwitchDrawMode,
    hnSwitchKeyMapping,
    hnLoadXlatMenu,
    hnLoadXlatExt,
    hnLoadXlatTable,
    hnUpWord,
    hnUpString,
    hnLoWord,
    hnLoString,
    hnCapWord,
    hnCapString,
    hnChangeCharCase,
    hnChangeCaseWord,
    hnChangeCaseString,
    hnChangeCaseChrRan,
    hnChangeCaseWrdRan,
    hnChangeCaseStrRan,
    hnReverseWord,
    hnReverseString,
    hnEditCrLfMode,
    hnEditLfMode,
    hnEditCrMode,
    hnSelectSyntax,
    hnReHighLite,
    hnEncryptText,
    hnDecryptText,
    hnCountCharsWords,
    hnSwitchShowLines,
    hnInsertCoolText,
    hnInsertUsingFont,
    hnBracketPair,
    hnWordLeft,
    hnWordRight,
    hnNumberLeft,
    hnNumberRight,
    nhEdit,
    nhParagraph,
    nhBlock,
    nhMisc,
    nhOptions,
    nhBookmarks,
    hnMark,
    nhMoveIndent,
    nhGoto,
    nhFormat,
    nhSortOper,
    nhInsert,
    nhDelete,
    nhSwap,
    hnUpperCase,
    hnLowerCase,
    hnCapitalize,
    hnChangeCase,
    hnRandomCase,
    hnReverse,
    hnLineType,
    hnQuoteLeft,
    hnQuoteRight,
    hnAscii,
    hnFileDialog,
    hnFindFileArc,
    hnYesButton,
    hnNoButton,
    hnOKButton,
    hnCancelButton,
    hnInternetDownload,
    hnPluginManager,
    hnJumpToSameF,
    hnUserCLeft,
    hnUserCRight,
    hnDiskEdit,
    hnFlatView,
    hnDigitCnv,
    hnSpecialPath,
    hnOpenFiles
  );

{ Strings }
  TStrIdx = (
    dlAltTable,
    erInvalidFormula,
    erInvalidCell,
    erInvalidValue,
    erInvalidFunction,
    erRecurseTooDeep,
    erDeepDependence,
    erInvalidFileFormat,
    erInvalidIF,
    erGotoInvalidNumber,
    erCantReadHistory,
    erCantReadDesktop,
    erDesktopError,
    erInvalidDesktop,
    erCantCreateFile,
    erNotEnoughMemory,
    erCantOpenConfig,
    erCantOpenHelp,
    erInvalidDrive,
    erInvalidFileName,
    erNotDiskSpace1,
    erNotDiskSpace2,
    erTextNotFound,
    erNoQuickDirs,

    eruuNoStuff,
    eruuUnknownMode,
    eruuBlankLine,
    eruuNonUULine,
    eruuLineNo,
    eruuIncorrectTerm,

    erVideoModeNotSupported,
    erVideoModeInputBad,
    erVideoModeExists,

    dlUUDecoding,

    dlEnableCPUID,

    dlHexLabel,
    dlPrevButton,
    dlPromptForQDir,
    dlOpenFile,
    dlOpenFileName,
    dlSaveFileAs,
    dlSaveFileAsName,
    dlFileExist,
    dlCanNotWrite,
    dlOptions,
    dlCellDialog,
    dlCellAsIs,
    dlCellDec,
    dlCellBool,
    dlCellCurrency,
    dlCellDisplay,
    dlCellJLeft,
    dlCellJRight,
    dlCellJCenter,
    dlCellJustify,
    dlCellCurrencyName,
    dlCellDecimals,
    dlCellWidth,
    dlCellExponent,
    dlCellNothing,
    dlCellProtect,
    dlCellComma,
    dlCellPercent,
    dlGotoCellNum,
    dlGotoCellName,
    dlFindCellTitle,
    dlFindCellPattern,
    dlFindCellSensitive,
    dlFindCellWhole,
    dlFindCellSearchAs,
    dlFindCellString,
    dlFindCellValue,
    dlReplaceTitle,
    dlReplacePattern,
    dlReplacePrompt,
    // don't change button order start
    dlRetryButton,
    dlYesButton,
    dlOKButton,
    dlNoButton,
    dlNextButton,
    dlAppendButton,
    dl2YesButton,
    dlAllButton,
    dlCancelButton,
    // don't change button order end
    dlHelpButton,
    dlTreeButton,
{$IFDEF REANIMAT}
    dlReanimateButton,
{$ENDIF}
    dlDriveButton,
    dlViewButton,
    dlHexASCIIButton,
    dlMkDirButton,
    dlRereadButton,
    dlOverwriteButton,
    dlSkipButton,
    dlYesForAll,
    dlRead,
    dlWrite,
    dlChooseDir,
    dlChooseFile,
    dlColors,
    dlColorsGroup,
    dlColorsItem,
    dlColorsText,
    dlColorsBack,
    dlColorsColor,
    dlColorsNormal,
    dlColorsHighlight,
    dlColorsUnderline,
    dlColorsInverse,

    dlDBViewNumeric,
    dlDBViewMemo,
    dlDBViewLogical,
    dlDBViewFloat,
    dlDBViewPicture,
    dlDBViewEmpty,
    dlDBViewNoMemo,
    dlDBViewViewMemo,
    dlDBViewInfo,
    dlDBViewInfoString,
    dlDBViewSearchNot,
    dlDBViewSearch,
    dlDBViewTextSearch,
    dlDBEditField,
    dlDBValue,
    dlDBCantEdit,
    dlDBEmptyStruc,
    dlDBRecNo,

    dlDICurDir,
    dlDINoFiles,
    dlDINoSubDirs,
    dlDISubDirs,
    dlDISubDir,
    dlDIFiles,
    dlDIBytes,
    dlDIFile,
    dlDIByte,
    dlDIWith,
    dlDITotalDisk,
    dlDIFreeDisk,
    dlDIFree,
    dlDIOn,
    dlDIVolumeID,
    dlDIMemoryTotal,
    dlDIMemoryForUser,
    dlDIMemoryForDN,
    dlDIPhysMemory,
    dlDIVirtMemory,
    dlDIEMS1,
    dlDIEMS2,
    dlDIXMSFree,
    dlDIUMBFree,
    dlDIMemUMBFree,
    dlDINone,
    dlDISerialNo, { Rainbow }
    dlDIFileSys, { Rainbow }

    dlStdDlgManyFiles,
    dlDirectory,
    dlFile,
    dlDrive,
    dlFiles,
    dlDirectoriesLabel,
    dlClear,
    dlOpen,
    dlStop,
    dlStop2,
    dlReplace,
    dlWarning,
    dlCloseButton,
    dlOCloseButton,
    dlCopyButton,
    dlRenameButton,
    dlDTDiskFull1,
    dlDTDiskFull2,
    dlEraseRO,
    dlEraseCantDelDir,
    dlEraseDirNotEmpty,
    dlEraseConfirm1,
    dlEraseConfirms1,
    dlEraseConfirm2,
    dlErase,
    dlErasingFile,
    dlErasingDir,
    dlErasingNoFile,
    dlEraseConfirmDir,
    dlFBBNotReadSource,
    dlFBBOver1,
    dlFBBOver2,
    dlFBBInsertDisk,
    dlFBBDiskFull1,
    dlFBBNoCreate,
    dlFBBNoWrite,
    dlFBBDiskFull2,
    dlFBBFragment,
    dlFBBDEFragment,
    dlFBBFragmentTo,
    dlFBBNoOpen,
{ Chem O`Dun fix 19-11-01 19:05:38 desc =  ய 䠩  訡    ஢}
    dlFBBNoOpenSkip,
{ Chem O`Dun fix 19-11-01 19:05:38 stop}
    dlSplit_to,
    dlFlushingBuffers,
    dlComparing,
    dlFCOver,
    dlFCItself,
    dlFCNotDiskSpace,
    dlFCCopy1,
    dlFCMove1,
    dlFCCopy2,
    dlFCMove2,
    dlFCNoRename1,
    dlFCNoRename2,
    dlDIDir,
    dlFCNoCreateDir,
    dlFCCopy,
    dlFCMove,
    dlFCcantCopyDir,
    dlFCcantCopyFile,
    dlFCtoFile,
    dlFCtoDir,
    dlFCVerifyFailed,
    dlSelectedFiles,
    dlTotal,
    dlFileFind,
    dlTempDrive,
    dlNoFilesFound,
    dlFilesFound,
    dlChangeDir,
    dlSetAttr,
    dlSortName,
    dlSortExt,
    dlSortType,
    dlSortDate,
    dlSortDateAcc,
    dlSortDateCre,
    dlSortSize,
    dlSortUnsorted,
    dlSortDescription,
    dlSortRatio,
    dlSortPackedSize,
    dlSortSelected,
    dlSortAllocSize,
    dlSortNumber,
    dlSortInverted,
    dlSortDirFirst,
    dlSortDirsByName,
    dlSortTag,
    dlViewQuery,
    dlViewSearchFor,
    dlViewCase,

    dlArcMsg1,
    dlArcMsg5,
    dlArcMsg6,
    dlArcMsg7,
    dlArcMsg8,
    dlArcMsg9,
    dlArcConfinMenu,
    dlArcReadArc,
    dlArcExtract,
    dlArcDest,
    dlArcSetPsw,
    dlArcMove,
    dlArcAdd,
    dlArcInto,
    dlArcOpt,
    dlArcDelete,
    dlArcName,
    dlArcUSize,
    dlArcPSize,
    dlArcRatio,
    dlArcDate,

    dlQueryExit,
    dlStoreColorPal,
    dlLoadColorPal,
    dlFileName,
    dlDisconnect,
    dlPercentComplete,
    dlTopName,
    dlLFN,
    dlTopSize,
    dlTopTime,
    dlTopDate,
    dlTopPath,
    dlTopOriginal,
    dlTopPacked,
    dlTopRatio,
    dlTopPID,
    dlTopPPID,
    dlTopCPU,
    dlTopMemory,
    dlTopStatus,
    dlSsRun,
    dlSsStop,
    dlSsPause,
    dlServStoping,
    dlServRunning,
    dlServStop,
    dlServStop1,
    dlServRun,
    dlServRun1,
    dlProcKill,
    dlProcKill1,
    dlProcKilling,
    dlNetScan,
    dlServScan,
    dlAccessDeny,
    dlInput,
    dlServerName,
    dlUserDomain,
    dlUsrnmPassw,
    dlMacAddress,
    dlIPAddress,
    dlASCIIChart,
    dlWorksheet,
    dlNotSaved,
    dlExportTitle,
    dlExportLabel,
    dlRunButton,
    dlDropButton,
    dlKillButton,
    dlDeleteButton,
    dlWindowsLabel,
    dlWindowManager,
    dlPhoneBook,
    dlPhonesLabel,
    dlPhonesLabelGroup,
    dlPhonesLabelPhones,
    dlPhonesUpDir,
    dlDialButton,
    dlEditButton,
    dlPhoneAppend,
    dlPhoneDelete,
    dlPhoneDeleteQuery,
    dlFileManager,
    dlJanuary,
    dlFebruary,
    dlMarch,
    dlApril,
    dlMay,
    dlJune,
    dlJuly,
    dlAugust,
    dlSeptember,
    dlOctober,
    dlNovember,
    dlDecember,
    dlCluster,
    dlSector,
    dl1st,
    dl2nd,
    dl3rd,
    dlSometh,
    dlCopyOfFAT,
    dlReservedSector,
    dlDiskFixer,
    dlFixerFill,
    dlCopyTo,
    dlNumberClusters,
    dlStartingCluster,
    dlValidClusters,
    dlClusterRange,
    dlNumberSectors,
    dlStartingSector,
    dlValidSectors,
    dlSectorRange,
    dlSBootSector,
    dlBootSector,
    dlS1stFAT,
    dlS2ndFAT,
    dlRootDirectory,
    dlUnusedDirEntry,
    dlSearchProgress,
    dlPasteFromTitle,
    dlPasteFromLabel,
    dlQueryModified,
    dlReadingFile,
    dlWritingFile,
    dlQueryReplace,
    dlEditTitle,
{$IFDEF REANIMAT}
    dlReanimateTitle,
    dlReanimateView,
    dlReanimateHead,
    dlReanimateScan,
    dlReanimateDirectory,
    dlReanimateRecovered,
    dlReanimateGood,
    dlReanimatePoor,
    dlReanimateAverage,
    dlReanimateWrite,
    dlCantReanimate,
    dlCantReanimateDirectory,
    dlReanimateNone,
{$ENDIF}
    dlGameTitle,
    dlNewButton,
    dlSetupButton,
    dlTop10Button,
    dlPauseButton,
    dlTetName,
    dlTetrisBest,
    dlTetrisNext,
    dlUndo,
    dlGameScore,
    dlGameLevel,
    dlGameLines,
    dlGameScore2,
    dlGameInfo,
    dlTetris,
    dlPentix,
    dlTop10,
    dlGameOver,
    dlTotalWrite,
    dlTotalWrited,
    dlBytes,
    dlViewTitle,
    dlExportingDIZ,
    dlDeletingDIZ,
    dlDeletingSource,
    erIntoItself,
    dlCreatingDirectory,
    dlPhoneDirDelete,
    dlPleaseStandBy,
    dlArcPacking,
    dlArcUnpacking,
    dlLoadingViewer,
    dlLoadingEditor,
    dlErrorsOccurred,
    dlSelectDirectory,
    dlScreenSaverSetup,
    dlSS_S_electedSavers,
    dlSS_A_dd,
    dlSS_R_emove,
    dlSSA_v_ailableSavers,
    dlSS_T_ime,
    dlSSUse_M_ouse,
//
    dlBigCalculator,
    dlCalculator,
    dlCalcEx_p_ression,
    dlCalcCopy_a_s,
    dlEvaluateButton,
    dlCalcCopyButton,
    dlDecoTitle,
//
    dlUnknownWindowType,
    dlColorsTitle,
    dl_C_olor,
    dl_B_ackground,
    dl_F_oreground,
    dl_I_tem,
    dl_G_roup,
{$IFDEF FORMAT}
    dlFmtOs2Warning,
    dlFmtAdvWarning,
    dlFmtMsgStr,
    dlFmtTimeStr,
    dlFmtNewDisk,
    dlFmtContQuery,
    dlFmtErrorSysAreas,
    dlFmtNoDisk,
    dlFmtDiskProtected,
    dlFmtDiskFormatted,
    dlFmtNonDos,
    dlFmtQuickFormat,
    dlFmtTrack0Bad,
    dlFmtNoSysFiles,
    dlFmtBadInterleave,
    dlFmtNoFloppy,
    dlFmt_F_astFormat,
    dlFmt_D_OSFormat,
    dlFmt_S_afeFormat,
    dlFmt_Q_uickFormat,
    dlFmt_M_akeDiskBootable,
    dlFmtFo_r_cedFormatting,
    dlFmtMarkFullTrack,
    dlFmtOptimi_z_eSectors,
    dlFmtAdvButton,
    dlFmtStartButton,
    dlFmtAreYou,
    dlFmtDriveHas1,
    dlFmtDriveHas2,
    dlFmtDriveLabel,
    dlFmtCapacityLabel,
    dlFmtVolumeL,
    dlFmtFTypeLabel,
    dlFmtTitle,
{$ENDIF}
    dlFBBBinary,
    dlFBBVerify,
    dlQueryCreateDir,
    dlQueryAbort,
    dlFCNotOverDir,
    dlNotRenameDir,
    dlFCRename,
    dlFCRenameNew,
    dlNoPossibleName,
    dlEditDesc,
    dl_D_escription,
    dlFC_Writing,
    dlFC_Written,
    dlFC_Total,
    dlFC_To,
    dlFC_Reading,
    dlFC_WasRead,
    dlFCCheckingDirs,
    dlFC_Older,
    dlFC_Exists,
    dlFC_Over,
    dlFC_of,
    dlFC_Elapsed,
    dlFC_Estimated,
    dlFC_Skip,
    dlQueryCancelSearch,
    dlReadingList,
    dlListDriveTop,
    dlFillQuery,
    dlSystemInfo,
    dlSI_Ports,
    dlSI_OSVer,
    dlSI_Lpt,
    dlSI_COM,
    dlSI_Memory,
    dlSI_Main,
    dlSI_MainBoard,
    dlSI_Expanded,
    dlSI_Extended,
    dlSI_DiskDrivers,
    dlSI_1stHard,
    dlSI_2ndHard,
    dlSI_FloppyDrives,
    dlSI_Heads,
    dlSI_Tracks,
    dlSI_SectTrack,
    dlSI_NotPresent,
    dlNoCPUID,
    dlInternal,
    dlSI_HardDrive,
    dlSI_TotalMem,
    dlSI_Conventional,
    dlDetailButton,
    dlTSRTitle,
    dlMemoryInfo,
    dlHookVectors,
    dlUnknown,
    dlMI_CmdLine,
    dlMI_PgmPath,
    dlMI_DeviceHandle1,
    dlMI_DeviceHandle2,
    dlMI_DeviceName,
    dlMI_DeviceFlags,
    dlMI_ResArea,
    dlMI_Files,
    dlMI_Buffers,
    dlMI_FCBs,
    dlMI_Drives,
    dlMI_Stacks,
    dlMI_IFS,
    dlMI_XBuffers,
    dlMsgWarning,
    dlMsgError,
    dlMsgInformation,
    dlMsgConfirm,
    dlMsgQuery,
    dlMsgAbout,
{$IFDEF MEMMAP}
    dlJump,
    dlMemoryMap,
    dlMemDescriptor,
{$ENDIF}
    dlED_VertNeed,
    dlED_Printed,
    dlED_Print,
    dlED_PrintQuery,
    dlED_PrintLine,
    dlED_PrintNothing,
    dlED_OpenFile,
    dlED_OverQuery,
    dlED_ModifyRO,
    dlED_NoBlockOp,

    dlModemNoSetup,
    dlNoModemPort,
    dlManualDial,
    dl_P_honeNumber,
    dlMD_Manual,
    dlPB_SearchPhone,
    dlPB_S_earchString,
    dlPB_NoFind,
    dlPB_ImportPhones,
    dlPB_Working,
    dlPB_CnvReport,
{$IFDEF MODEM}
    dlAutoDialer,
    dlAD_Name,
    dlAD_Queue,
    dlAD_Status,
    dlAD_Redial,
    dlAD_ForceDial,
    dlAD_Delete,
    dlAD_HoldUnhold,
    dlAD_Unhold,
    dlAD_Hold,
    dlAD_Dialing,
    dlAD_Holded1,
    dlAD_Holded2,
    dlAD_NoDial,
    dlAD_ModemSays,
{$ENDIF}
    dlPrintingPaused,
    dlPrinting,
    dlPrintOut,
    dlPrintNoInit,
    dlPrintCancelQuery,
    dlPManagerTitle,
    dlPDeleteQeury1,
    dlPDeleteQeury2,
    dlCantPrint,
    dlCantPrintFile,
{$IFDEF MODEM}
    dlTermProtocol,
    dlTermProtocolFile,
    dlTermProtocolRece,
    dlTermProtocolSent,
    dlTermProtocolErrors,
    dlTermProtocolEstimate,
    dlTermReceXmodem,
    dlTermReceiving,
    dlTermWaitAnswer,
    dlTermSendFile,
    dlTermSending,
    dlTermWriteFile,
    dlTermSetLog,
    dlTermCommandsHistory,
    dlTermCopy_H_istory,
    dlTermCopy_C_lipboard,
    dlTerminalTitle,
{$ENDIF}
    dlScanningDirs,
    dlTreeFilesWith,
    dlTree1FileWith,
    dlMNUNotFound,
    dlMenuParams,
    dlMenuParamLabel,
    dlGrabWelcome,
    dlValueNotInRange,
    dlEnvVarLabel,
    dlEnvDelConfirm,
    dlEnvAddTitle,
    dlEnvVariable,
    dlEnvRenVar,
    dlSI_BuiltIn,
    dlSI_None,

    dlTeam000,
    dlTeam001,
    dlTeam002,
    dlTeam003,
    dlTeam004,
    dlTeam005,
    dlTeam006,
    dlTeam007,
    dlTeam008,
    dlTeam009,
    dlTeam010,
    dlTeam011,
    dlTeam012,
    dlTeam013,
    dlTeam014,
    dlTeam015,
    dlTeam016,
    dlTeam017,
    dlTeam018,
    dlTeam019,
    dlTeam020,
    dlTeam021,
    dlTeam022,
    dlTeam023,
    dlTeam024,
    dlTeam025,
    dlTeam026,
    dlTeam027,
    dlTeam028,
    dlTeam029,
    dlTeam030,
    dlTeam031,
    dlTeam031a,
    dlTeam031b,
    dlTeam031c,
    dlTeam032,
    dlTeam033,
    dlTeam034,
    dlTeam035,
    dlTeam036,
    dlTeam037,
    dlTeam038,
    dlTeam039,
    dlTeam040,
    dlTeam041,
    dlTeam041a,
    dlTeam042,
    dlTeam043,
    dlTeam044,
    dlTeam045,
    dlTeam046,
    dlTeam047,
    dlTeam048,
    dlTeam049,
    dlTeam050,
    dlTeam051,
    dlTeam052,
    dlTeam053,
    dlTeam054,
    dlTeam055,
    dlTeam056,
    dlTeam057,
    dlTeam058,
    dlTeam059,
    dlTeam060,
    dlTeam061,
    dlTeam062,
    dlTeam063,
    dlTeam064,
    dlTeam065,
    dlTeam066,
    dlTeam067,
    dlTeam068,
    dlTeam069,
    dlTeam070,
    dlTeam071,
    dlTeam072,
    dlTeam073,
    dlTeam074,
    dlTeam075,
    dlTeam076,
    dlTeam077,
    dlTeam078,
    dlTeam079,
    dlTeam080,
    dlTeam081,
    dlTeam082,
    dlTeam083,
    dlTeam084,
    dlTeam085,
    dlTeam086,
    dlTeam087,
    dlTeam088,
    dlTeam089,
    dlTeam090,
    dlTeam091,
    dlTeam092,
    dlTeam093,
    dlTeam094,
    dlTeam095,
    dlTeam096,
    dlTeam097,
    dlTeam098,
    dlTeam099,
    dlTeam100,
    dlTeam101,
    dlTeam102,
    dlTeam103,
    dlTeam104,
    dlTeam105,
    dlTeam106,
    dlTeam107,
    dlTeam108,
    dlTeam109,
    dlTeam110,
    dlTeam111,
    dlTeam112,
    dlTeam113,
    dlTeam114,
    dlTeam115,
    dlTeam116,
    dlTeam117,
    dlTeam118,
    dlTeam119,
    dlTeam120,
    dlTeam121,
    dlTeam122,
    dlTeam123,
    dlTeam124,
    dlTeam125,
    dlTeam126,
    dlTeam127,
    dlTeam128,
    dlTeam129,
    dlTeam130,
    dlTeam131,
    dlTeam132,
    dlTeam133,
    dlTeam134,
    dlTeam135,
    dlTeam136,
    dlTeam137,
    dlTeam138,
    dlTeam139,

    dlNetInfo,
    dlFileInfoI,
    dlServer,
    dlConnections,
    dlLookedFiles,
    dlVeryDeepSearch,
    dlLookedDirs,
    dlSE_Dir2Long,
    stDaysWeek,

    dlHelp,
    dlOutputTitle,
{$IFDEF SAMEGAME}
    dlSameGameTitle,
    dlStopButton,
    dlMarked,
{$ENDIF}
    dlCDSaveButton,
{$IFDEF CDPLAYER}
    dlCDPlayer,
    dlCDPlayerNoCD,
    dlCDTrack,
    dlCDPlayTrack,
    dlCDSelectTrack,

    dlCDTrackButton,
    dlCDAddButton,
    dlCDDeleteButton,
    dlCD_R_Button,
    dlCD_C_Button,

    dlCDTrackTime,
    dlCDTrackLeft,
    dlCDDiskTime,
    dlCDDiskLeft,

    dlCDButtonRew,
    dlCDButtonPrev,
    dlCDButtonPlay,
    dlCDButtonNext,
    dlCDButtonFFwd,
    dlCDButtonPause,
    dlCDButtonStop,
    dlCDButtonEject,

    dlCDButtonSet,
    dlCDButtonTime,
    dlCDButtonMode,
    dlCDButtonMix,
    dlCDButtonOrder,
    dlCDButtonTitle,

    dlNoCD,
    dlCloseCD,
{$ENDIF}
    dlDIVirtual,
    dlDIFileFind,
    dlDIFFMask,
    dlBranch,
    dlDICurArchive,
    dlDIArcTotalFiles,
    dlDIPackedSize,
    dlDIUnpackedSize,
    dlUpDir,
    dlSubDir,
    dlSymLink,
    dlDFS,
    dlSymLink1,
    dlHardLink,
    dlJunction,
    dlSocket,
    dlPlainFile,
    dlBlockDevice,
    dlCharDevice,
    dlFifo,
    dlWKZ_Empty,
    dlPM_Print,
    dlArvid_Title,
    dlArvid_Type,
    dlArvid_TimeUsed,
    dlArvid_TimeLeft,
    dlArvid_TapeDir,
    dlHash,
    dlUUEncode,
    dlUUEncoding,
    dlUUDecode,
    dlUUDecodingto,
    dlUUencodeSFN,
    dlUUencodeOS,
    dlUUencodeCreated,
    dlUUencodeTime,
    dlUUencodeSize,
    dlUUencodeSections,
    dlUUencodeLines,
    dlUUDecodeFiles,
    dlUUDecodeErrors,
    dlFileIsSmall,
    dlMaxFiles,

    dlleSection,
    dlleSections,
    dlleListed,
    dlleCalculated,
    dlleFileSizeMismatch,
    dlleFileCRCMismatch,
    dlleErrorOpenTMP,
    dlleCantCreate,
    dlleFailedToDecode,
    dlleFileNameExp,
    dlleFileNamesMismatch,
    dlleFileTimeExp,
    dlleInvFileTimeNum,
    dlleCRC_Err,
    dlleSizeMism,
    dlleChkSumFmt,
    dlleSectionHdr,
    dlleMaxSectNumMism,
    dlleDuplicateSection,
    dlleOfFile,
    dlleIsAbsent,
    dlleAreAbsent,
    dlleUnexpEND,
    dlleNoTerm,
    dlleFailedFinal,

    dlOverflow,
    dlElapsedTime,
    dlEditHistory,
    dlReplacesMade,
    dlScrollBack,

    dlColorsBlack,
    dlColorsDark,
    dlColorsGray,
    dlColorsWhite,
    dlColorsColors,
    dlColorsDefault,
    dlColorsBlinking,
    dlColorsB_W_,
    dlColorsMono,
    dlColors_VGA,
    dlColors_P_alette,
    dlColorsColor_,
    dlColors_R_ed,
    dlColors_G_reen,
    dlColors_B_lue,
    dlColors_G_ray,
    dlColors_D_efault,

    dlColors_C00,
    dlColors_C01,
    dlColors_C02,
    dlColors_C03,
    dlColors_C04,
    dlColors_C05,
    dlColors_C06,
    dlColors_C07,
    dlColors_C08,
    dlColors_C09,
    dlColors_C10,
    dlColors_C11,
    dlColors_C12,
    dlColors_C13,
    dlColors_C14,
    dlColors_C15,
    dlAutoexecWarning,
    dlSelectXLT,
    dlSetDirHistory,
    dlSetEditHistory,
    dlSetViewHistory,
    dlSetDecoHistory,
    dlDirectoryHistory,
    dlWPDFiles,
    dlWPDFolders,
    dlWPDSize,
    dlWPDSkip,
    dlWPDScanFolder,
    dlWPDContinue,
{$IFDEF MODEM}
    dlLinkTitle,
    dlLinkStarted,
    dlLinkClose,
    dlLinkErrors,
    dlLinkWaitingCmd,
    dlLinkSendingFile,
    dlLinkReceivingFile,
    dlLinkWaitFile,
    dlLinkQueryExit,
    dlLinkNoRemote,
    dlLinkTransmitFile,
    dlLinkNoRemoteLink,
    dlLinkRemoteError,
    dlLinkRemoteWait,
    dlLinkEraseDirCfm,
    dlLinkErasingFile,
    dlLinkErase,
    dlLinkRemoteDirInfo,
    dlLinkSend,
    dlLinkRcv,
{$ENDIF}
    dlNoFTNset,

    dlBytesOf,
    dlExecDOScmdHdr,
    dlExecDOScmdLine,
    dlPnlDescription,

    dlCE_CriticalError,
    dlCE_WriteProtected,
    dlCE_DiskNotReady,
    dlCE_DataIntegrity,
    dlCE_SeekError,
    dlCE_UnknownMedia,
    dlCE_SectorNotFound,
    dlCE_OutOfPaper,
    dlCE_WriteFault,
    dlCE_ReadFault,
    dlCE_GeneralFailure,
    dlCE_BadImageOfFAT,
    dlCE_DeviceError,
    dlCE_InsertDisk,
    dlCE_SharingViolation,
    dlCE_WrongDisk,
    dlCE_DiskFull,
    dlCE_DeviceInUse,
    dlCE_Filename_Exced_Range,
    dlCE_Dirty_Flag,
    dlCE_Filename_Illegal,
    dlCE_ErrWndTitle,
    // don't change button order start
    dlCE_ButAbort,
    dlCE_ButRetry,
    dlCE_ButIgnore,
    dlCE_ButIgnoreAll,
    // don't change button order end
    dlViewSaveXlat,
    dlDataError,
    dlFrenameFile,
    dlFFileName,
    dlNOXLT,
    dlDenieErase,
    dlEnterValue,
    dlEnterValuecr,
    dlCancel,
    dlOk,
    dlNastr,
    dlSmp1,
    dlSmp2,
    dlColorsVGA,
    dlAbout,
    dlCharDecHex,
    dlWereErrors,
    dlDescription1,
    dlDescription2,
    dlDescription3,
    dlDescription4,
    dlDescription5,
    dlDescription6,
    dlDescription7,
    dlDescription8,
    dlDescription9,
    dlDescription10,
    dlDescription11,
    dlDescription12,
    dlDescription13,
    dlDescription14,
    dlDescription15,
    dlDescription16,
    dlDescription17,
    dlDescription18,
    dlDescription19,
    dlDescription20,
    dlDescription21,
    dlDescription22,
    dlDescription23,
    dlDescription24,
    dlDescription25,
    dlNoVga,
    dlRUSure,
    dlNoLfn,
    dlNdnSpf,
    dlcTitle,
    dlcWeek,
    dlcJanuary,
    dlcFebruary,
    dlcMarch,
    dlcApril,
    dlcMay,
    dlcJune,
    dlcJuly,
    dlcAugust,
    dlcSeptember,
    dlcOctober,
    dlcNovember,
    dlcDecember,
    dlArvidNeedDisk,
    dlArvidCmdFileCreated,
    dlArvidCmdFileAppended,
    dlArvidCanChangeOnlyAVT,
    dlArvidVolumeIsNotTape,
    dlArvidNoReal,
    dlSI_NT,
    dlPresent,
    dlAbsent,
    dlPktView,
    dlPktHeader,
    dlPktFile,
    dlPktMsg,
    dlViewMsg,
    dlSaveMsg,
    dlMsgFile,
    dlErrorWriting,
    dlNetMailView,
    dlLastMsg,
    dlFirstMsg,
    dlDelMsg,
    dlNotPkt,
    dlReadingPkt,
    dlLine,
    dlFileMask,
    dlImageError,
    dlOpenNewWindow,
    dlAnonymous,
    dlMenuItemOn,
    dlMenuItemOff,
    dlTeamHint,

    dlDBTableCodepage,
    dlDBLastModified,
    dlDBTableType,
    dlDBLanguageDriver,
    dlDBFieldDescriptorAS,
    dlDBHeaderLength,
    dlDBRecordLength,
    dlDBRecordCounts,
    dlDBFieldsCounts,
    dlDBIndexUsedFlag,
    dlDBCharacter,
    dlDBGeneral,
    dlDBInteger,
    dlDBDateTime,
    dlDBCurrency,
    dlDBDouble,
    dlDBDate,
    dlDBFloat,
    dlDBLogical,
    dlDBMemo,
    dlDBNumeric,
    dlDBPicture,
    dlDBViewCharacter,
    dlDBViewDate,
    dlDBViewName,
    dlDBDeleTeRecord,
    dlDBRecoverRecord,
    dlDBSeparator,
    dlDBTableEncr,

    dlNoAdminRights,

    dlCGFileName,
    dlCGGroupIndex,
    dlCGDirectory,
    dlCGUseDefBG,
    dlCGForeground,
    dlCGBackground,
    dlCGPreview,
    dlCGModifyI,
    dlCGNewItem,
    dlCGRUSure,
    dlCGFileGrp,
    dlCGFnG,
    dlCGFni,
    dlCGColor,
    dlCGModify,
    dlCGNew,
    dlCGDelete,
    dlCGAdjust,
    dlCGDir,
    dlINIMod,
    dlFileSearch,
    dlPitonLength,
    dlTestButton,
    dlErrVolume,
    dlHelpError,
    dlDBGotoRec,
    dlEditHistoryNotExist,
    dlAlarm,
    dlModal,
    dlEveryDay,
    dlAt,
    dlExecPrg,
    dlMonth,
    dlDay,
    dlHour,
    dlMin,
    dlSec,
    dlMessage,
    dlEver_yDay,
    dlEveryWeek,
    dlOverdue,
    dlDelAfter,
    dlAutoClose,
    dlCalendar,
    dlNewItem,
    dlModifyItem,
    dlAlarmList,
    dlItems,
    dlModify,
    dlNew,
    dlDelete,
    dlAdjust,
    dlAllow,
    dlMore,
    dlNone,
    dlApplyForAll,
    dlCannotStore,
    dlViewerError,
    dlSize,
    dlDate,
    dlTime,
    dlPath,
    dlDesc,
    dlPack,
    dlRati,
    dlLong,
    dlArcChoose,
    dlFilDir,
    dlDirectories,
    erRegExpCompile,
    erRegExpCompPos,
    dlColorsElem,
    dlColorsID,
    dlColorsTestText,
    dlReloadQuery,
    dlMacroNotFound,
    dlQuickDirNotDefined, {AH 25-11-03}
    dlQuickDirNotFound, {AH 29-11-03}
    dlRestart,          {AH  6-12-03 }
    dlCountLen,         {AH 11-12-03 }
    dlCountFolderSize,  {Garl 13-05-2019}
    dlMNUTitle,         {Garl 4-02-05}
    dlMNUvideo,
    dlMNUdrive,
    dlMNUQuickDirChange,
    dlSort,
    dlDMChange,
    dlDMaddNetwork,
    dlDMRename,
    dlCDOpen,
    dlCDClose,
    dlDMRemNew,
    dlDMTitle,
    dlColsModeSetup,
    dlDisk,
    dlFind,
    dlTemp,
    dlArvd,
    dlList,
    dlArch,
    dlLink,
    dlProc,
    dlEraseHistories, {AH 29-11-05 prompt before deleting history}
    dlHistoryEmpty,
    dlRestoreFile, {AH 21-01-06 prompt before restoring files}
    dlDBViewHeaderError, {Garl 8-07-06}
  {$IFDEF LINUX}
    dlNoVCSA, {AH  8-05-06 show info string if no VCSA available}
{$ENDIF}
//
    erBlockTooBig,
    dlInvalidValue,
    dlQueryTruncate,
    dlFileNotOpen,
    dlS_i_gn,
    dlCPUInfo,
    dlCompressing,
    dlDeCompressing,
    dlSelectLogicalDisk,
    dlSelectPhyscalDisk,
    dlPnlAttr,
    dlChamps,
    dlEmptyRecycle,
    dlDoCompressFiles,
    dlDeCompressFiles,
    dlShutdownComputer,
// extension size
    dlAll,
    dlAllFiles,
    dlCount,
    dlEScaption,
    dlExtension,
    dlExtensions,
    dlExtensionsSize,
    dlFileSize,
    dlFilesLabel,
    dlGoto,
    dlMaxFile,
    dlOrder,
    dlReadDir,
    dlScanFolders,
    dlTotalSize,
    dlMap,
    dlVesaInfo,
    dlNoVESA,
    dlUpdatedNDN,
    dlNDNOK,
//
    dlSafeRemove,
    dlUnSubst,
    dlKeyCode,
    dlSelectArchitecture,
    dlCurrentFile,
    dlFind2,
    dlCodePage,
    dlDefault,
    dlSaveCP,
    dlConfirmKill,
    dlCantKill,
    dlConfirmClose,
    dlCantClose,
    dl_S_earch,
    dl_L_ist,
    dlFailedToLoadHelpFile,
    dlModalHelp,
    dlNoHelpForThisTopic,
    dldwLength,
    dldwMemoryLoad,
    dldwTotalPhys,
    dldwAvailPhys,
    dldwTotalPageFile,
    dldwAvailPageFile,
    dldwTotalVirtual,
    dldwAvailVirtual,
    dlVolumeSysFlags,
    dlViewStr,
    dlCursorSize,
    dlCursorChange,
    dl_N_ormal,
    dl_B_lock,
    dl_Adapt_,
    dl_D_efault,
{$IFDEF NEWHELP}
    dlErrorHelpFile,
{$ENDIF}
    dlConfirmDeleteItem,
    dlRound,
    dlOxygen,
    dlPoints,
{$IFDEF CWMANIA}
    dlMask,
    dl_R_esults,
    dlFindWord,
    dlFindAnag,
    dlFindRegExp,
    dlPleaseWait,
    dlOpenDictionary,
    dlDictQuery,
    dlOperationBreak,
    dlNoWordsFound,
    dlNoAnagsFound,
    dlIsSearching,
    dlWordsFound,
    dlAnagsFound,
    dlAddWord,
    dlRemoveWord,
    dlWordToAdd,
    dlWordToRemove,
    dlWordIsAlready,
    dlNoThisWord,
    dlImportDict,
    dlImportFile,
    dlKindMustBeTheSame,
    dlImportedWords,
    dlIsImporting,
    dlCreateNewDic,
    dlSelectDictLang,
    dlAngLng,
    dlPolLng,
    dlRusLng,
    dlGerLng,
{$ENDIF}
    dlPreparing,
    dlFilters,
    dlCurrentPanel,
    dlInactivPanel,
    dlTopCTime,
    dlTopLTime,
    dlAllocated,
    dlStrTotal,
    dlStrFree,
//
    dlWipeRO,
    dlWipeCantDelDir,
    dlWipeDirNotEmpty,
    dlWipeConfirm1,
    dlWipeConfirms1,
    dlWipeConfirm2,
    dlWipe,
    dlWipingFile,
    dlWipingDir,
    dlWipingNoFile,
    dlWipeConfirmDir,
//
    dlAlcSize,
    dlLostSpace,
//
    dlClock,
    dlUseFont,
//
    dlAuto,
    dlHint,
    dlYourMove,
    dlFlag,
//
    dlSquares1,
    dlSquares2,
    dlStartButton,
//
    dlSaveCPUInf,
    dlSaveButton,
//
    dlCantLoad,
{$IFDEF OS2}
    dl_Failed_to_enumerate_EA,
    dl_Failed_to_retrieve_EA,
    dl_Failed_to_store_EA,
    dl_Critical_EA_Copy_Fail,
    dlEditEALongname,
    dl_EALongname,
    dl_Failed_to_set_volume_label,
    dlOperationNotValidForDdrive,
    dlCreateObject,
    dlObjectTitle,
{$ENDIF}
{$IFDEF TASKLIST}
    dlTasklist,
    dlSwitchButton,
{$ENDIF}
    dlConfirmUndoDis,
    dlDownloading,
    dlErrorsDuringOperation,
    dlAge,
    dlUnitAge,
    dlMoves,
    dlYourTime,
    dlGoToSpecialWindowsFolder, // \ +0
    dlGoToEnviromentVarsFolder, // / +1
//
    dlFileNameTooLong,
    dlPrecision,
//
    dlzzz
  );

{ NOTE: ALL dlg* types which are used in RCP.PAS (dlgMainMenu, dlgStatusBar...)
        MUST be before any conditional types (FTP, CDPLAYER...) else there will
        be index problems when compiling the resources}
  TDlgIdx = (
//
    dlgDecoderHexMode,
    dlgDecoderTxtMode,
    dlgGotoAddressEx,
    dlgSaveScreen,
    dlgDecodeBytes,
    dlgDecodeBytesEx,
    dlgAssemble,
    dlgModifications,
    dlgSafeFill,
    dlgFillBlock,
    dlgReadBlock,
    dlgWriteBlock,
    dlgDeleteBlock,
    dlgInsertBlock,
    dlgAppend,
    dlgDelete,
    dlgInsert,
//
    dlgHNFind,
    dlgHFFind,
//
    dlgSelect,
    dlgUnselect,
    dlgSetupArc,
    dlgCommandsHistory,
    dlgExtract,
    dlgSetPassword,
    dlgCompareDirs,
    dlgFilesAttr,
    dlgFileAttr,
    dlgFMSetup,
    dlgFMDefaults,
    dlgPanelSetup,
    dlgDriveInfoSetup,
    dlgDiskError,
    dlgMakeList,
    dlgCopyDialog,
//    dlgRenameDialog,
    dlgMkDir,
    dlgOpenEd,
    dlgRenFl,
    dlgRenFlLinks,
    dlgRenFlHardLink,
    dlgCreateLink,
    dlgFileFind,
    dlgFileFindArc,
    dlgEditorReplace,
    dlgEditorFind,
    dlgEditorFormat,
    dlgGotoLine,
    dlgHighlightGroups,
    dlgColors,
    dlgWkzMenuBar,
    dlgSetCellFormat,
    dlgGotoCellNumber,
    dlgFindCell,
    dlgReplaceCell,
    dlgDbFind,
    dlgGameSetup,
    dlgPrinterSetup,
    dlgEditDirectory,
    dlgAppendDirectory,
    dlgEditNumber,
    dlgAppendNumber,
    dlgMainMenu,
    dlgStatusLine,
    dlgEditorDefaults,
    dlgViewerDefaults,
    dlgDBFDefaults,
    dlgDisAsmDefaults,
    dlgSystemSetup,
    dlgSaversSetup,
    dlgInterfaceSetup,
    dlgMouseSetup,
    dlgStartupSetup,
    dlgArchiveFiles,
    dlgReenterPassword,
    dlgAdvanceSearch,
    dlgCountrySetup,
    dlgConfirmations,
    dlgaLfnSetup,
//    dlgRegExSetup,
    dlgGlobalSetup,
    dlgEditorCommands,
    dlgEditorMenu,
    dlgGotoAddress,
    dlgPhoneBook,
    dlgDenie,
    dlgManualDial,
    dlgCalculator,
    dlgCalculatorEx,
    dlgWindowManager,
    dlgVolumeLabel,
    dlgEditEnvironment,
    dlgTetrisWinner,
    dlgSplitFile,
    dlgCombineFile,
    dlgPitonTop10,
    dlgTetrisTop10,
    dlgPentixTop10,
    dlg2048Top10,
    dlgSameGameTop10,
    dlgAdvancedFilter,
    dlgUUDecode,
    dlgUUEncode,
    dlgUUEncode2,
    dlgOverwriteQuery,
    dlgViewerFind,
    dlgArvidFileFind,
    dlgArvidFindResults,
    dlgDirectoryHistory,
    dlgEditHistory,
    dlgViewHistory,
    dlgDecoHistory,
    dlgCmdLineSetup,
//    dlgColumnDefaultsDisk,
//    dlgColumnDefaultsFind,
//    dlgColumnDefaultsTemp,
//    dlgColumnDefaultsArch,
//    dlgColumnDefaultsArvd,
    dlgFilesOp,
    dlgNextSection,
    dlgGameSetupP,
    dlgUnpackDisketteImages,
    dlgExeHeader,
    dlgPEHeader,
    dlgLEHeader,
    dlgNEHeader,
    dlgELFHeader,
    dlg3PHeader,
    dlgPEPlusHeader,
    dlgAdamHeader,
    dlgViewerReplace,
    dlgInitXX,
    dlgSetFileSize,
    dlgFillArea,
    dlgInsertBytes,
    dlgRemoveBytes,
    dlgChangeBase,
    dlgAddNewVideoMode,{AH 10-09-04 COD}
    dlgColsDefSetup,
//    dlgCpuFlagInfo,
    dlgColsDefaults, {AH 10-03-04 all columns}
    dlgMiscMultiSetup,
{$IFDEF NETWORK}
    dlgAddNetwork,{AH 21-12-04}
{$ENDIF}
    dlgNetworkSetup,{G 22-10-2018}
    dlgLoginPassword,      {G 23-12-2014}
    dlgServerLoginPassword,{G 9-10-2018}
    dlgServer,            {G 11-10-2018}
    dlgPanelSetupX,       {G 12-10-2018}
    dlgFileAttributes,    {G  6-12-2018}
    dlgFilesAttributes,   {G  2-05-2019}
{$IFDEF LINUX}
    dlgFileFlags,         {G 12-11-2019}
    dlgFilesFlags,        {G 14-11-2019}
    dlgLinuxFileAtt,      {G 21-10-2019}
    dlgLinuxFilesAttr,    {G 22-10-2019}
{$ENDIF}
//{$IFNDEF LINUX}
    dlgAttribSymbol,      {G 28-04-2020}
//{$ENDIF}
    dlgArscSetup,

{$IFDEF EXTENSIONSIZE}
    dlgDirSize, {G 26-02-2019}
{$ENDIF}
{$IFDEF G2048}
    dlgGameSetup2,        {G  7-11-2018}
{$ENDIF}
{$IFDEF SHUTDOWN}
    dlgShutdown,{AH 14-02-05}
{$ENDIF}
{$IFDEF DISKEDIT}
    dlgFixerMenu,
{$ENDIF}
{$IFDEF MODEM}
    dlgAdvancedCOMSetup,
    dlgSetupModem,
    dlgSetupTerminal,
{$ENDIF}
{$IFDEF FTP}
    dlgFTPHostSetup,
{$ENDIF}
{$IFDEF CDPLAYER}
    dlgCDOptions,
{$ENDIF}
{$IFDEF DPMI32}
    dlgGraphModeFont,
    dlgKeybSetup,
{$ENDIF}
    dlgIconControlMenu,
    dlgWindowControlMenu,
    dlgHashes,
    dlgUpDateNDN,
{$IFDEF TESTTAB}
    dlgTestTab,
{$ENDIF}
    dlgSelectCodePage,
    dlgTaskList,
    dlgSelectHash,
    dlgHlpMenu,
{$IFDEF NEWHELP}
    dlgGoToTopic,
{$ENDIF}
    dlgAdvFormat,
    dlgPacManTop10,
    dlgPacManSetup,
{$IFDEF DPMI32}
    dlgVideoModeList,
{$ENDIF}
{$IFDEF CWMANIA}
    dlgDictioaryMenu,
{$ENDIF}
    dlgExport,
    dlgImport,
    dlgDirectories,
    dlgProperties,
{$IFDEF WPD}
    dlgWPDCopyDialog,
    dlgWPDMkDir,
    dlgFileFindWPD,
{$ENDIF}
    dlgInfoFATS,
{$IFDEF WIN32}
    dlgInfoNTFS,
{$ENDIF}
    dlgInsertString,
    dlgConsideredString,
    dlgHTMLFind,
    dlgSquaresTop10,
{$IFDEF CRLF}
    dlgChangeCRLF,
{$ENDIF}
    dlgSelectSyntax,
{$IFDEF CRYPTEDITOR}
    dlgCryptPassword,
{$ENDIF}
    dlgGotoCol,
    dlgInsertCoolText,
{$IFDEF WIN32}
    dlgInternetDownload,
{$ENDIF}
    dlgPluginManager,
    dlgPluginDetail,
{$IFDEF DIGITCNV}
    dlgDigitCnv,
{$ENDIF}
{$IFDEF OPENEDFILES}
    dlgFindOpenedFile,
    dlgNextOpenedFile,
{$ENDIF}
{$IFDEF MAXITGAME}
    dlgMaxitSetup,
{$ENDIF}
    dlgDetailsAbout,
    dlgCalcFormat,
    dlgEmpty
  );

implementation

end.
