{ Necromancer's Dos Navigator defines file... }
{ }
{ these must be defined by user/in the main compiler options                 }
{ NDN      - always, will be undefined if RCP/TVHC is requested. But this is
             required to be added to external units, like the DPMI32 ipstack }
{ RCP/TVHC - if RCP/TVHC are the targets                                     }
{ RELEASE  - if RELEASE is compiled                                          }
{ Remember that this file is used by RCP for compiling resources             }

{ GENERAL DEFINES }
{$IFDEF VIRTUALPASCAL}
{$DEFINE VP}
{$DEFINE VPOBJ}
  {$IFNDEF NODIRECTIV}
  {$X+,R-,I-,S-,Q-,P-,Cdecl-,Delphi+,Use32+,Speed+,Optimise+,B-,H+,W-,G3+,SmartLink+,Z+}
  {$IFDEF WIN32}{$AlignCode+}{$ELSE}{$AlignCode-}{$AlignData-}{$ENDIF}
  {$IFDEF PLUGIN1}{$AlignCode-}{$AlignData-}{$ENDIF}
  {$ENDIF}
{$ENDIF}
{ PROGRAM DEFINES }
{$IFNDEF NDN}
  STDEFINE - FATAL ERROR: Please define "NDN" in the main compiler configuration!
{$ENDIF}

{$DEFINE ERRORHANDLING}

{$IFDEF PLUGIN1}{$UNDEF ERRORHANDLING}{$ENDIF}

{$IFDEF MEN}            { MenuetOS X32 Target (quasi x64)               }
  {$DEFINE KOL}
  {$DEFINE _KOL_}       { Rename function not implemented in MenuetOS   }
  {$DEFINE CROSSMEN}    { Use also crosscompile directives              }
  {$UNDEF ERRORHANDLING}{ No exception handling in MenuetOS             }
{$ENDIF}

{$IFDEF SIG}    { SigmaOS x86 Target                                    }
  {$DEFINE KOL}
  {$DEFINE CROSSSIG}    { Use also crosscompile directives              }
{$ENDIF}

{$DEFINE NDN}   { This is here because several programs parse this file }
{$DEFINE REALNDN}
{$DEFINE RELEASE}

{$IFDEF RCP}    {$IFNDEF COMMANDSUNIT}{$UNDEF NDN}{$UNDEF REALNDN}{$ENDIF COMMANDSUNIT}    {$ENDIF}
{$IFDEF TVHC}   {$IFNDEF COMMANDSUNIT}{$UNDEF NDN}{$UNDEF REALNDN}{$ENDIF COMMANDSUNIT}    {$ENDIF}

{$IFDEF RCP}
  {$DEFINE TABS}
  {$DEFINE TVUTILS}
  {$DEFINE SHOWHINT}
  {$DEFINE CALCINRPC}
  {$DEFINE USE_NEW_HISTORY}
{$ENDIF}

{$IFDEF WIN32}{$IFNDEF DPMI32}{$DEFINE ISW32}{$DEFINE WINXL}{$ENDIF}{$ENDIF}
{$IFDEF WIN64}{$IFNDEF DPMI32}{$DEFINE ISW64}{$DEFINE WIN32}{$ENDIF}{$ENDIF}

{$IFNDEF RCP}
  {$IFNDEF TVHC}
    {$IFNDEF NDN}
      {$IFNDEF GENLIB}
      STDEFINE - FATAL ERROR: Either NDN, RPC or TVHC must be defined!
      {$ENDIF}
    {$ENDIF}
  {$ENDIF}
{$ENDIF}

{$IFDEF FPC}
//{$DEFINE HASWCHAR}       { Use WideString as PPalette in Views.PAS }
  {$DEFINE HASWIDE}        { Use WideString                          }
  {$DEFINE HASINT64}
  {$IFDEF WIN64}
  {$IFDEF DPMI32}
    {$DEFINE DPMI64}
  {$ENDIF}
  {$ENDIF}
{$ENDIF}

{$DEFINE VIEWHASID}        { View has identification number                  }

{$IFDEF WIN32}  {$DEFINE DW32} {$ENDIF}
{$IFDEF DPMI32} {$DEFINE DW32} {$ENDIF}
{$IFDEF WIN64}  {$DEFINE DW32} {$DEFINE DW64} {$ENDIF}
{$IFDEF DPMI64} {$DEFINE DW32} {$DEFINE DW64} {$ENDIF}

{$IFDEF DPMI32}
  {$DEFINE DPMI32K}        { DPMI32 or Kolibri                               }
{$ENDIF}
{$IFDEF DW32}
  {$DEFINE DW32KOL}        { DPMI/WIN or Kolibri                             }
{$ENDIF}
{$IFDEF LINUX}
  {$DEFINE LINUXKOL}       { LINUX or Kolibri                                }
  {$DEFINE WINXL}          { LINUX or Windows                                }
{$ENDIF}

{}
{$IFDEF RELEASE}           { Defines only for an official release            }
  {$UNDEF DEBUG}
{$ELSE}                    {Defines not to be included in an official release}
  {$DEFINE DEBUG}          { Enable debug options / defines                  }
  {$DEFINE DEVELOPING}     { Enable functions in development                 }
  {$DEFINE BETA}
  {$DEFINE CHDIRTIMER}     { Shift+Return show timer on dir change           }
  {.$DEFINE MEMLEAKS}      { Detect memory leaks                             }
  {.$DEFINE DEMO}          { Demo Version                                    }
  {.$DEFINE PLUGINS}
{$ENDIF}

{ DEBUG OPTIONS }
{$IFDEF DEBUG}
  {.$DEFINE DEBUGCODE}     { defines.pas                        }
  {.$DEFINE DEBUGMODUS}    { defines.pas                        }
  {.$DEFINE VPDBGDLL}      { defines.pas                        }

  { OS specific debug options }

  {$IFDEF WIN32}           { WINDOWS specific debug options     }
    {$DEFINE DEBUG_W32}
  {$ENDIF}

  {$IFDEF DPMI32}          { DOS specific debug options         }
    {$DEFINE DEBUG_D32}
    {.$DEFINE DEBUG_LINK}  { Include deb_link                   }
  {$ENDIF}

  {$IFDEF LINUX}           { LINUX specific debug options       }
    {$DEFINE DEBUG_LNX}
  {$ENDIF}
{$ENDIF}

{}
{ RCP + NDN need these }
{$IFNDEF TVHC}
  {$DEFINE CHECKBOXESE_SCROLLBAR} { Support Checkboxes with Scrollbars      }
  {$DEFINE CHCOL}           { Change colors menu                            }
  {$DEFINE SS}              { Screen Savers                                 }
{$ENDIF}

{$IFDEF NDN}
  {$DEFINE DIGITCNV}        { Digital Converter                             }
  {$DEFINE LIFE}            { Life simulation                               }
  {$DEFINE NEXTRPN}         { Next RPN Calculator                           }
  {$DEFINE DUALPAL}         { Dual palette support                          }
  {$DEFINE REGEXP}          { Regular expressions                           }
  {$DEFINE ALARM}           { Alarm clock                                   }
  {$DEFINE ARVID}           { Arvid support                              VFS}
  {$DEFINE ASCII}           { Ascii - table                                 }
  {$DEFINE CALCULAT}        { Calculator                                    }
  {$DEFINE CALENDAR}        { Calendar                                      }
  {$DEFINE ALTCAL}          { Alternative Calendar                          }
  {$DEFINE CALENDAR_SELECT} { Calendar can be selected like any other window}
  {$DEFINE DBFVIEW}         { DBase files viewer                            }
  {$DEFINE DISASM}          { Disassembler/Decoder in viewer                }
//{$DEFINE OLDDISASM}       { Pascal code old disassembler replaced by new  }
  {$DEFINE DISKIMG}         { Disk Images handling                          }
  {$DEFINE FBB}             { File splitting support                        }
  {$DEFINE FILETYPE}        { File types highliting                         }
  {$DEFINE PHONES}          { Phone book                                    }
  {$DEFINE PITON}           { Pitonchik game                                }
  {$DEFINE G2048}           { Game 2048                                     }
  {$DEFINE PKTVIEW}         { Fido .pkt files viewer                        }
  {$DEFINE SPREADSHEET}     { Spread Sheet                                  }
  {$DEFINE CRUX}            { Crux game                                     }
  {$DEFINE GOMOKU}          { GoMoku game                                   }
  {$DEFINE MEMORY}          { Memory game                                   }
  {$DEFINE MINESW}          { Minesweeper game                              }
  {$DEFINE PACMAN}          { Pac-Man game                                  }
  {$DEFINE PUZZLE}          { Puzzle game                                   }
  {$DEFINE TETRIS}          { Tetris game                                   }
  {$DEFINE SAMEGAME}        { same game                                     }
  {$DEFINE SQUARES}         { Squares game                                  }
  {$DEFINE BEAST}           { Beast game                                    }
  {$DEFINE TRASHCAN}        { Trash can                                     }
  {$DEFINE CPUINFO}         { CPU Info                                      }
  {$DEFINE UUCODE}          { UU encoding/decoding                          }
  {$DEFINE UUENCODE}        { UU encoder                                    }
  {$DEFINE UUDECODE}        { UU decoder                                    }
  {$DEFINE DN}              { piton/linkutil.pas                            }
  {$DEFINE OS_DOS}          { objects.pas                                   }
  {$DEFINE NFAST}           { dnformat/format.pas                           }
  {$DEFINE CL_MASTER}       { linktyp/linkutil.pas                          }
  {$DEFINE ORG_DEBUG}       { trees.pas                                     }
  {$DEFINE RESTORETEMPFILES}{ Extract/Download, Edit, Store again           }
  {$DEFINE NEW_HELP_WINDOW} { New help window handling                      }
  {$DEFINE FILECHANGENOTIFY}{ Signal changes to opened files                }
  {$DEFINE USE_NEW_HISTORY} { Advanced histories in inputlines              }
  {$DEFINE DECODER}         { Decoder                                       }
  {$DEFINE FILECOMPARE}     { Binary file compare                           }
  {$DEFINE HN}              { Views Help Navigator's files                  }
  {$DEFINE EXTENSIONSIZE}   { File size by extensions                       }
  {$DEFINE TABS}            { Tabbed group                                  }
  {$DEFINE SHOT}            { Screen shot creator                           }
  {$DEFINE SILHISTORY}      { Search by Input Line in History               }
  {$DEFINE CALCINRPC}       { Calculator in RCP                             }
  {$DEFINE IMPORTHLP}       { Import other help files                       }
  {$DEFINE ELEVATION}       { AutoRun as Admin                              }
  {$DEFINE DISKINFO}        { Current disk information                      }
  {$DEFINE PROPERTIES}      { File Properties                               }
  {$DEFINE HASH}            { Hash calculating procedures                   }
  {$DEFINE MINIMIZE}        { Minimize windows code                         }
  {$DEFINE SHUTDOWN}        { usage of func shutdown or not                 }
  {$DEFINE UNPACK}          { Resources can be compressed                   }
  {$DEFINE LOADDLG}         { Load all dialogs resource                     }
  {$DEFINE LOADHLP}         { Load all help files                           }
  {$DEFINE TVUTILS}         { Additional utils                              }
  {$DEFINE CWMANIA}         { CrossWordMania - search words in dictionary   }
  {$DEFINE ANALOGCLOCK}     { Analog Clock                                  }
  {$DEFINE HTMLVIEW}        { Simple HTML file viewer                       }
  {$DEFINE CRLF}            { CR/LF convert line ending                     }
  {$DEFINE CRYPTEDITOR}     { En/De-Crypt in editor                         }
  {$DEFINE RPNCALC}         { RPN calculator                                }
  {$DEFINE SHOWLOGO}        { Show Logo                                     }
  {$DEFINE SHOWHINT}        { Draw hints like in TV                         }
  {$DEFINE EDITCODE}        { Editor & Highlight code - less resource size  }
  {$DEFINE DISKEDIT}        { Disk Image Editor (FAT12,FAT16,FAT32)         }
  {$DEFINE MAXITGAME}       { Cool Maxit Game                               }
  {$DEFINE ADDSPECDRV}      { Add special fake drives "." & "\"             }
{$IFNDEF MEN}
  {$DEFINE LOGFILE}         { Logging to file                               }
{$ENDIF}
  {$IFDEF DEVELOPING}       { development code used in all targets          }
  {$ENDIF}

  {$IFDEF DPMI32}           { DPMI32 specific ----------------------------- }
    {$DEFINE FASTDNINI}     { Faster load DN.INI                            }
    {$DEFINE NEWLOADINI}    { New code to load ini files                    }
    {$DEFINE MEMMAP}        { Show memory descriptors by BIOS E820 function }
    {$DEFINE CDPLAYER}      { Compact disk player                           }
    {$DEFINE EXTKBD}        { Extended keyboard manager for DPMI32          }
    {$DEFINE MEMINFO}       { Memory Information                            }
    {$DEFINE MOUSE}         { Mouse customization                           }
    {$DEFINE PRINTMAN}      { File printing manager                         }
    {$DEFINE CLOSENOTIFY}   { Notify NDN that the window will be closed     }
    {$DEFINE OSENV}         { OS Environment editor                         }
    {$DEFINE FTP}           { FTP Support                                   }
    {$DEFINE FORMAT}        { Disk formatting                               }
    {$DEFINE SYSINFO}       { System information                            }
    {$DEFINE VESAINFO}      { VESA information                              }
    {$DEFINE DETECTVM}      { detect emulators like DOSBOX, VMware etc      }
    {$DEFINE SPEAKER}       { Sounds by PC Speaker                          }
    {$DEFINE DISKEDIT}      { Disk Editor (FAT12,FAT16,FAT32)               }
  {$IFNDEF PLUGIN1}
    {$DEFINE PLUGIN}        { Support Plugins                               }
  {$ENDIF}
  {$IFDEF DEVELOPING}       { these seem to be DPMI32 only                  }
    {.$DEFINE APRO}         { \ Modem connection                            }
    {.$DEFINE MODEM}        { /                                             }
    {.$DEFINE DISKTOOL}     { Unit used by following units (MemAdjust)      }
    {.$DEFINE REANIMAT}     { Reanimator                                    }
  {$ENDIF}
  {$ENDIF DPMI32}

  {$IFDEF WIN32}            { WIN32 specific ------------------------------ }
    {$DEFINE PRINTMAN}      { File printing manager                         }
    {$DEFINE PROCESS}       { VFS_PROC Process Handling                     }
    {$DEFINE FTP}           { FTP Support                                   }
    {$DEFINE CONTEXTMENU}   { Context Menu support                          }
    {$DEFINE NETWORK}       { Network Resources display                     }
    {$DEFINE SERVICES}      { Windows Services display                      }
    {$DEFINE SYMLINKS}      { Symbolic links Juctions and full attributes   }
    {$DEFINE TRAYICON}      { Show Windows system tray icon and notify      }
    {$DEFINE OSENV}         { OS Environment editor                         }
    {$DEFINE DIRCHANGENOTIFY}{ Signal changes in watched directories        }
    {$DEFINE UPDATE}        { Check new version update                      }
    {$DEFINE TASKBAR}       { Show Taskbar icons                            }
    {$DEFINE PLUGIN}        { Support Plugins                               }
    {$DEFINE OPENEDFILES}   { Find Opened/Locked Files                      }
    {$IFDEF DEVELOPING}
    {$ENDIF}
  {$ENDIF}

  {$IFDEF LINUX}            { LINUX specific ------------------------------ }
    {$DEFINE PROCESS}       { VFS_PROC Process Handling                     }
    {$DEFINE STOREPATHS}    { LFN CurrentPaths usage                        }
    {$DEFINE FTP}           { FTP Support                                   }
    {$DEFINE DIRCHANGENOTIFY}{ Signal changes in watched directories        }
    {$DEFINE OSENV}         { OS Environment editor                         }
  {$ENDIF}
{$ENDIF NDN}

{}

{$IFDEF VP}
{$IFNDEF NODIRECTIV}
{$IFNDEF ERRORHANDLING}
  {$D-,LocInfo-,Zd-}
{$ELSE}
  {$D+,LocInfo+,Zd+}
  {$IFDEF DEBUG}
    {.$R+,I+,S+,Q+}         { Full error checking                           }
  {$ENDIF}
{$ENDIF}
  {$IFDEF DPMI32}{$IFDEF REALNDN}
    {$DEFINE CHESS}
  {$ENDIF}{$ENDIF}
{$ENDIF}{$ENDIF VP}

{}

{$DEFINE GAMES}
{$IFNDEF PITON}  {$UNDEF GAMES} {$ENDIF}
{$IFNDEF G2048}  {$UNDEF GAMES} {$ENDIF}
{$IFNDEF TETRIS} {$UNDEF GAMES} {$ENDIF}

{$IFDEF LINUX}
  {$DEFINE UNIX_RIGHTS}
{$ELSE}
  {$IFDEF FTP}
    {$DEFINE UNIX_RIGHTS}
  {$ENDIF}
{$ENDIF}

{$IFDEF DPMI32}
  {.UNDEF FTP}
  {.UNDEF NETWORK}
  {.UNDEF SOCKETS}
{$ELSE}
  {$DEFINE NETWORK}
  {$UNDEF SOCKETS}
{$ENDIF}

{$IFDEF DPMI64}
  {.$UNDEF FTP}
  {.$UNDEF NETWORK}
  {.$UNDEF SOCKETS}
{$ENDIF}

{$DEFINE SOCKETS}
{$IFNDEF FTP} {$UNDEF SOCKETS} {$ENDIF}

{$DEFINE USE_LZMA}
{$DEFINE COMPRESS_HELP}

{$IFDEF FPC}
  {$DEFINE FPCFOR}          { FPC/TMT for instruction ends with last value  }
  {$DEFINE BIGCALC}
  {$IFNDEF DPMI32}
    {$DEFINE CAPSTONE}
    {$DEFINE ZYDIS}
  {$ENDIF}
  {$IFNDEF NODELPHI}{$MODE DELPHI}{$ENDIF}
  {$INLINE ON}
  {$I-}
  {$H+}
  {$V-}
  {$A1}
  {$Z1}
  {$DEFINE PACKED}
  {$UNDEF WINDOWS}
{$ENDIF}

{ OS DEFINES }

{$IFDEF DCC}
  {$I-}
  {$H+}
  {$J+}
  {$V-}
  {$P-}
  {$A1}
  {$Z1}
  {$O+} { Delphi has many bugs in optimization (for example MOVZX SI,SIL is assembled as MOVZX SI,DH) }
//{$DEFINE HASWCHAR}       { Use WideString as PPalette in Views.PAS }
  {$DEFINE HASWIDE}        { Use WideString                          }
  {$DEFINE HASINT64}
  {$IFNDEF VER185}{$CODEALIGN 1}{$ENDIF}
  {$DEFINE PACKED}
  {$DEFINE BIGCALC}
  {$IFDEF CPUX64}
    {$DEFINE DCC64}
    {$DEFINE _VER360_}
  {$ELSE}
    {$DEFINE DCC32}
  {$ENDIF}
  {$IFDEF DPMI32}
    {$DEFINE DCCD32}
  {$ELSE}
    {$IFNDEF VER360}
      {$DEFINE ASSIGN}
    {$ENDIF}
    {$DEFINE ISWIDE}
    {$IFDEF REALNDN}
    {$W+}
    {$DEFINE CALLSTK}
    {$ENDIF}
    {$UNDEF UUENCODE}
    {$UNDEF UUDECODE}
    {$UNDEF HTMLVIEW}
    {$UNDEF DISKEDIT}
  {$ENDIF}
  {$IFDEF DPMI32}
    {$UNDEF ISWIDE}
    {$UNDEF FTP}
    {$UNDEF NETWORK}
    {$UNDEF SOCKETS}
    {$UNDEF FASTDNINI}
    {$UNDEF NEWLOADINI}
  {$ENDIF}
  {$IFDEF DPMI64}
    {$UNDEF ISWIDE}
    {$UNDEF FTP}
    {$UNDEF NETWORK}
    {$UNDEF SOCKETS}
  {$ENDIF}
  {$IFNDEF VER185}
    {$STRONGLINKTYPES OFF}  { Because this directive defeats the smart linker to a large degree, it can cause inflation of the executable size. }
    {$WEAKLINKRTTI ON}      { Enables more Smart Linking => smaller EXE     }
  {$ENDIF}
{$ENDIF}

{$IFDEF ISW64}              { Only when WIN64                               }
  {$DEFINE CAPSTONE}
  {$DEFINE ZYDIS}
  {$DEFINE WPD}             { Windows Portable Devices (Media Tr Protocol)  }
{$ENDIF}

{$IFDEF RCP}
  {$UNDEF WPD}
  {$UNDEF ZYDIS}
  {$UNDEF CAPSTONE}
  {$UNDEF GAMES}
  {$UNDEF DISASM}
  {$UNDEF REGEXP}
  {$UNDEF BIGCALC}
  {$UNDEF DECODER}
  {$UNDEF DIGITCNV}
  {$UNDEF DISKINFO}
  {$UNDEF USE_LZMA}
  {$UNDEF ELEVATION}
  {$UNDEF PROPERTIES}
  {$UNDEF STOREPATHS}
  {$UNDEF FILECOMPARE}
  {$UNDEF COMPRESS_HELP}
{$ENDIF}

{$IFDEF LINUX}
  {$UNDEF CAPSTONE}
  {$UNDEF ZYDIS}
{$ENDIF}

{$IFDEF LITE}
  {$UNDEF CAPSTONE}
  {$UNDEF ZYDIS}
  {$UNDEF PLUGIN}
{$ENDIF}

{$IFNDEF DECODER}
  {$UNDEF DIGITCNV}
  {$UNDEF FILECOMPARE}
{$ENDIF}

{$IFDEF DPMI32}{$DEFINE FASTCLP}{$ENDIF}
{$DEFINE BIGINPUTLINE}      { AnsiString long input line                    }
{$DEFINE LARGEX}            { Large screen size (up to 512 chars)           }
{$DEFINE NEWKBD}            { New keyboard driver in Dos version            }
{$DEFINE EXTPAL}            { Extended global palette >= than 255 chars     }
{$DEFINE NEWHELP}           { New help files viewer                         }
{.DEFINE UUCODE2}           { UUCODE2 also work but without XXCODE/MIME     }
{.DEFINE TAGVIEW}           { not yet supported (TaggedView read data)      }
{.DEFINE STOREUNDOVIEW}     { less resource file size if not defined        }
{$IFDEF LINUX}{$IFDEF CPUX64}
  {$DEFINE NEWLNX}          { New Linux Code                                }
  {$DEFINE NEWDRV}          { New Linux Draw                                }
  {.DEFINE GPM2}            { Always commented, but also work (Linux64 ver) }
{$ENDIF}{$ENDIF}

{$IFDEF CROSSMEN}           { MenuetOS X32 Target                           }
  {$DEFINE CROSSKOL}        { Use also crosscompile directives              }
{$ENDIF}

{$IFDEF CROSSSIG}           { SigmaOS x86 Target                            }
  {$DEFINE CROSSKOL}        { Use also crosscompile directives              }
{$ENDIF}

{$IFDEF KOL}                { KolibriOS target                              }
  {$DEFINE NEWLOADINI}      { New code to load ini files                    }
  {$DEFINE CROSSKOL}        { Use also crosscompile directives              }
  {$DEFINE LINUXKOL}        { Linux or Kolibri                              }
  {$DEFINE DW32KOL}         { DPMI/WIN or Kolibri                           }
  {$DEFINE DPMI32K}         { DPMI32 or Kolibri                             }
  {$DEFINE SPEAKER}         { Sounds by PC Speaker                          }
  {$IFNDEF PLUGIN1}
    {$DEFINE PLUGIN}        { Support Plugins                               }
  {$ENDIF}
{$ENDIF}
{$IFDEF CROSSKOL}           { KolibriOS target crosscompiled in Dos         }
  {$DEFINE STOREPATHS}      { LFN CurrentPaths usage                        }
  {}
  {$UNDEF FTP}
  {$UNDEF NETWORK}
  {$UNDEF SOCKETS}
  {}
  {$UNDEF DEBUG_D32}
  {$UNDEF MEMMAP}
  {$UNDEF CDPLAYER}
  {$UNDEF EXTKBD}
  {$UNDEF MEMINFO}
  {$UNDEF MOUSE}
  {$UNDEF PRINTMAN}
  {$UNDEF CLOSENOTIFY}
  {$UNDEF OSENV}
  {$UNDEF FORMAT}
  {$UNDEF SYSINFO}
  {$UNDEF VESAINFO}
{$ENDIF}

{$IFDEF OS2}
  {$DEFINE CROSSOS2}        { Use also crosscompile directives              }
{$ENDIF}
{$IFDEF CROSSOS2}           { OS2 target crosscompiled in Dos               }
  {$DEFINE OSENV}
  {$DEFINE TASKLIST}
  {}
  {$UNDEF FTP}
  {$UNDEF NETWORK}
  {$UNDEF SOCKETS}
  {}
  {$UNDEF DEBUG_D32}
  {$UNDEF MEMMAP}
  {$UNDEF CDPLAYER}
  {$UNDEF EXTKBD}
  {$UNDEF MEMINFO}
  {$UNDEF MOUSE}
  {$UNDEF PRINTMAN}
  {$UNDEF CLOSENOTIFY}
  {$UNDEF FORMAT}
  {$UNDEF SYSINFO}
  {$UNDEF VESAINFO}
  {}
{$ENDIF}

{$IFDEF HAIKU}
  {$DEFINE CROSSHAI}        { Use also crosscompile directives              }
  {$DEFINE LINUX}
  {$DEFINE LINUXKOL}        { LINUX or Kolibri                              }
  {$DEFINE WINXL}           { LINUX or Windows                              }
  {$DEFINE NEWLNX}          { New Linux Code                                }
  {$DEFINE NEWDRV}          { New Linux Draw                                }
  {$DEFINE OSENV}           { OS Environment editor                         }
  {$DEFINE UNIX_RIGHTS}
  {$DEFINE STOREPATHS}
  {$DEFINE NOPOWER}
{$ENDIF}

{$IFDEF CROSSHAI}           { HAIKU target crosscompiled in Windows         }
  {}
  {$UNDEF WPD}
  {$UNDEF FTP}
  {$UNDEF NETWORK}
  {$UNDEF SOCKETS}
  {}
  {$UNDEF SHUTDOWN}
  {$UNDEF CAPSTONE}
  {$UNDEF PLUGIN}
  {$UNDEF ZYDIS}
  {}
  {$DEFINE NOFASMX}
  {}
  {$DEFINE HAIKUKEYB}       { Special Haiku Keyboard Service                }
  {$DEFINE DUALKEYB}        { Keyboard - via GetKeyMap()                    }
  {}
{$ENDIF}

{$IFDEF SOLARIS}
  {$DEFINE CROSSSOL}        { Use also crosscompile directives              }
  {$DEFINE LINUX}
  {$DEFINE LINUXKOL}        { LINUX or Kolibri                              }
  {$DEFINE WINXL}           { LINUX or Windows                              }
  {$DEFINE NEWLNX}          { New Linux Code                                }
  {$DEFINE NEWDRV}          { New Linux Draw                                }
  {$DEFINE OSENV}           { OS Environment editor                         }
  {$DEFINE UNIX_RIGHTS}
  {$DEFINE STOREPATHS}
  {$DEFINE NOPOWER}
{$ENDIF}

{$IFDEF CROSSSOL}           { Solaris target crosscompiled in Windows       }
  {}
  {$UNDEF WPD}
  {$UNDEF FTP}
  {$UNDEF NETWORK}
  {$UNDEF SOCKETS}
  {}
  {$UNDEF SHUTDOWN}
  {$UNDEF CAPSTONE}
  {$UNDEF ZYDIS}
  {}
  {$DEFINE NOFASMX}
  {}
{$ENDIF}

{$DEFINE USESCROLL}         { ScrollDialog in Minesweeper game              }
{.DEFINE _KOL_}             { Uncomment if file rename function not work K32}

{$IFDEF __TMT__}
  {$I-}
  {$A-}
  {$W-}
  {$OPTREG+}
  {$OPTFRM+}
  {$DEFINE TMT}             { TMT Pascal Compiler                           }
  {$DEFINE VPOBJ}           { VP/TMT OMF OBJECTS                            }
  {$DEFINE FPCFOR}          { FPC/TMT for instruction ends with last value  }
  {$DEFINE HASINT64}
  {$DEFINE NOSYSUTILS}
  {$DEFINE PACKED}
  {}
  {$UNDEF FTP}
  {$UNDEF NETWORK}
  {$UNDEF SOCKETS}
  {$UNDEF HASH}
  {$UNDEF WPD}
  {$UNDEF ZYDIS}
  {$UNDEF CAPSTONE}
  {$UNDEF ELEVATION}
  {$UNDEF NEWLOADINI}
{$ENDIF}

{$IFDEF BSD}
  {$DEFINE CROSSBSD}        { Use also crosscompile directives              }
  {$DEFINE LINUX}
  {$DEFINE LINUXKOL}        { LINUX or Kolibri                              }
  {$DEFINE WINXL}           { LINUX or Windows                              }
  {$DEFINE NEWLNX}          { New Linux Code                                }
  {$DEFINE NEWDRV}          { New Linux Draw                                }
  {$DEFINE OSENV}           { OS Environment editor                         }
  {$DEFINE UNIX_RIGHTS}
  {$DEFINE STOREPATHS}
  {$DEFINE NOPOWER}
{$ENDIF}

{$IFDEF CROSSBSD}           { BSD target crosscompiled in Windows           }
  {}
  {$UNDEF WPD}
  {$UNDEF FTP}
  {$UNDEF NETWORK}
  {$UNDEF SOCKETS}
  {}
  {$UNDEF SHUTDOWN}
  {$UNDEF CAPSTONE}
  {$UNDEF PLUGIN}
  {$UNDEF ZYDIS}
  {}
{$ENDIF}

//{$IFDEF ISWIDE}{$UNDEF CONTEXTMENU}{$ENDIF}
//{$IFDEF ISWIDE}{$DEFINE LONGSTRING}{$ENDIF}
{$IFDEF ZYDIS}{$DEFINE ZYDIS4}{$ENDIF}
